<?php

namespace App\Services;
use Illuminate\Http\Request;
use App\Branches;
use App\AdminItemGroup;
use App\ItemName;
use App\AdminSalesInvoice;
use App\AdminPurchaesInvoice;
use App\Customer;
use App\DebitNote;
use App\CreditNote;
use App\OpeningBalance;
class StockReportService
{

    public function completeStockReportClosingBalanceAndOpeningBalance($request, $from_date, $to_date)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $groups = AdminItemGroup::where('branch_id', session()->get('selected_branch'))->get();

        $itemNames = ItemName::with('unit')->where('branch_id', session()->get('selected_branch'))->get();

        $salesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    // ->groupBy('item_id')
                    // ->whereNotNull('invoice_no')
                    ->get();

        $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->whereIn('item_id', $itemNames->pluck('id'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();
        $openingBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->whereIn('item_id', $itemNames->pluck('id'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();

        $purchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->get();
        $salesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')

                ->get();
            // dd($salesReturnInvoices);
        $obSalesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    // ->groupBy('item_id')
                    ->whereNotNull('invoice_no')
                    ->get();

        $obPurchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();
        $obOpeningBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();
        $obPurchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();
        $obSalesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();

        $originalPurchaseInvoice = $purchaseInvoices->toArray();
        $openingBalanceForInventory = $openingBalanceForInventories->toArray();
        $salesInvoice = $salesInvoices->toArray();
        $purchaseReturn = $purchaseReturnInvoices->toArray();
        $salesReturn = $salesReturnInvoices->toArray();

        $obOriginalPurchaseInvoice = $obPurchaseInvoices->toArray();
        $obOpeningBalanceForInventory = $obOpeningBalanceForInventories->toArray();
        $obSalesInvoice = $obSalesInvoices->toArray();
        $obPurchaseReturn = $obPurchaseReturnInvoices->toArray();
        $obSalesReturn = $obSalesReturnInvoices->toArray();

        // Initialize variables
        $obWorkingSalesInvoices = $obSalesInvoice;

        // Copy original purchase invoices to work with
        $obWorkingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$obOriginalPurchaseInvoice);

        // Initialize arrays to store closing quantities and totals for each item_id
        $itemClosings = [];
        $obItemClosings = [];
        // Group original purchase invoices by item_id
        $obOriginalPurchaseInvoicesByItem = [];
        foreach ($obWorkingOriginalPurchaseInvoice as $purchase) {
            $item_id = $purchase['item_id'];
            if (!isset($obOriginalPurchaseInvoicesByItem[$item_id])) {
                $obOriginalPurchaseInvoicesByItem[$item_id] = [];
            }
            $obOriginalPurchaseInvoicesByItem[$item_id][] = $purchase;
        }

        // Group sales invoices by item_id
        $obSalesInvoicesByItem = [];
        foreach ($obSalesInvoice as $sale) {
            $item_id = $sale['item_id'];
            if (!isset($obSalesInvoicesByItem[$item_id])) {
                $obSalesInvoicesByItem[$item_id] = [];
            }
            $obSalesInvoicesByItem[$item_id][] = $sale;
        }

        // Iterate over each item_id
        foreach ($obOriginalPurchaseInvoicesByItem as $item_id => $purchases) {
            // Initialize closing total and quantity for the current item_id
            $obItemClosings[$item_id]['closingTotal'] = 0;
            $obItemClosings[$item_id]['closingQuantity'] = 0;

            // Calculate total cost and quantity from original purchases
            foreach ($purchases as $purchase) {
                $obItemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
                $obItemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
            }

            // Adjust for sales invoices
            if (isset($obSalesInvoicesByItem[$item_id])) {
                foreach ($obSalesInvoicesByItem[$item_id] as $sale) {
                    $saleQuantity = $sale['quantity'];

                    // Find corresponding original purchase invoices for this sale
                    foreach ($purchases as &$purchase) {
                        $soldQuantity = min($saleQuantity, $purchase['quantity']);
                        $saleQuantity -= $soldQuantity;
                        $purchase['quantity'] -= $soldQuantity;

                        // Update closing total and quantity
                        $obItemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $obItemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

                        if ($saleQuantity <= 0) {
                            break;
                        }
                    }
                }
            }
        }

        $obWorkingSalesReturn = array_merge($obSalesReturn);

        $obWorkingOriginalPurchaseInvoiceForReturns =  array_merge($obOpeningBalanceForInventory,$obOriginalPurchaseInvoice);


        foreach ($obWorkingSalesReturn as $return) {
            $returnedQuantity = $return['quantity'];
            $itemId = $return['item_id'];

            foreach ($obWorkingOriginalPurchaseInvoiceForReturns as &$purchase) {
                if ($purchase['item_id'] === $itemId) {
                    $purchaseQuantity = $purchase['quantity'];

                    $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

                    // Check if the keys exist before accessing them
                    if (isset($obItemClosings[$itemId]['closingTotal']) && isset($obItemClosings[$itemId]['closingQuantity'])) {
                        $obItemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $obItemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;
                    } else {
                        // If the keys don't exist, initialize them
                        $obItemClosings[$itemId]['closingTotal'] = $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $obItemClosings[$itemId]['closingQuantity'] = $returnToPurchaseQuantity;
                    }

                    $purchase['quantity'] -= $returnToPurchaseQuantity;
                    $returnedQuantity -= $returnToPurchaseQuantity;

                    if ($returnedQuantity <= 0) {
                        break;
                    }
                }
            }
        }


        foreach ($obPurchaseReturn as $return) {
            $returnedQuantity = $return['quantity'];

            $item_id = $return['item_id'];
            $obItemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
            $obItemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
        }

        // dd($obItemClosings);

        $workingSalesInvoices = $salesInvoice;

        // $workingOriginalPurchaseInvoice = $originalPurchaseInvoice;
        $workingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        $itemClosings = [];
        $originalPurchaseInvoicesByItem = [];
        foreach ($workingOriginalPurchaseInvoice as $purchase) {
            $item_id = $purchase['item_id'];
            if (!isset($originalPurchaseInvoicesByItem[$item_id])) {
                $originalPurchaseInvoicesByItem[$item_id] = [];
            }
            $originalPurchaseInvoicesByItem[$item_id][] = $purchase;
        }

        $workingSalesInvoice = array_merge($obSalesInvoice, $salesInvoice);

        // Group sales invoices by item_id
        $salesInvoicesByItem = [];
        foreach ($workingSalesInvoice as $sale) {
            $item_id = $sale['item_id'];
            if (!isset($salesInvoicesByItem[$item_id])) {
                $salesInvoicesByItem[$item_id] = [];
            }
            $salesInvoicesByItem[$item_id][] = $sale;
        }

        // Iterate over each item_id
        foreach ($originalPurchaseInvoicesByItem as $item_id => $purchases) {
            // Initialize closing total and quantity for the current item_id
            $itemClosings[$item_id]['closingTotal'] = 0;
            $itemClosings[$item_id]['closingQuantity'] = 0;

            // Calculate total cost and quantity from original purchases
            foreach ($purchases as $purchase) {
                $itemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
                $itemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
            }

            // Adjust for sales invoices
            if (isset($salesInvoicesByItem[$item_id])) {
                foreach ($salesInvoicesByItem[$item_id] as $sale) {
                    $saleQuantity = $sale['quantity'];

                    // Find corresponding original purchase invoices for this sale
                    foreach ($purchases as &$purchase) {
                        $soldQuantity = min($saleQuantity, $purchase['quantity']);
                        $saleQuantity -= $soldQuantity;
                        $purchase['quantity'] -= $soldQuantity;

                        // Update closing total and quantity
                        $itemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $itemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

                        if ($saleQuantity <= 0) {
                            break;
                        }
                    }
                }
            }
        }
        // Copy original purchase invoices to work with for sales returns
        // $workingOriginalPurchaseInvoiceForReturns = $originalPurchaseInvoice;
        $workingOriginalPurchaseInvoiceForReturns = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        $workingSalesReturn = array_merge($obSalesReturn, $salesReturn);

        foreach ($workingSalesReturn as $return) {
            $returnedQuantity = $return['quantity'];
            $itemId = $return['item_id'];

            // Iterate through copied original purchase invoices for returns
            foreach ($workingOriginalPurchaseInvoiceForReturns as &$purchase) {
                // Check if the item_id matches the returned item_id
                if ($purchase['item_id'] === $itemId) {
                    $purchaseQuantity = $purchase['quantity'];

                    // Calculate the quantity to be returned to the original purchase
                    $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

                    // Update closing total using the purchase rate
                    $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);

                    // Update closing quantity
                    $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;

                    // Reduce the quantity of the copied original purchase
                    $purchase['quantity'] -= $returnToPurchaseQuantity;

                    $returnedQuantity -= $returnToPurchaseQuantity;

                    if ($returnedQuantity <= 0) {
                        break; // No need to continue if all returned quantities are processed
                    }
                }
            }
        }

        $workingPurchaseReturn = array_merge($obPurchaseReturn, $purchaseReturn);

        // FIFO logic for debit notes (purchase returns)
        foreach ($workingPurchaseReturn as $return) {
            $returnedQuantity = $return['quantity'];

            // Update closing total and quantity for each returned item
            $item_id = $return['item_id'];
            $itemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
            $itemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
        }

        // // Output the closing quantities and totals for each item_id
        // dd($itemClosings);

        $combinedData = [];

        foreach ($itemNames as $item) {
            $itemId = $item->id;
            $itemName = $item->name;

            // $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0) + (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0);
            // $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) + (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);
            $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0);
            $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) ;

            // $obItemTotalQuantity = (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0) ;
            $obItemTotalRate = (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);

            $combinedData[] = [
                'itemId' => $itemId,
                'itemName' => $itemName,
                'unit' => $item->unit->unit,
                'group_id' => $item->group_id,
                'ItemTotalClosingQuantity' => $itemTotalQuantity,
                'ItemTotalClosingRate' => $itemTotalRate,
                'obItemTotalClosingRate' => $obItemTotalRate,
                'perItemRate' => ($itemTotalQuantity != 0) ? $itemTotalRate / $itemTotalQuantity : 0,

                // 'perItemRate' => ($itemTotalRate != 0) ? $itemTotalRate / $itemTotalQuantity : 0,
            ];
        }

        $groupedItems = [];

        foreach ($groups as $group) {
            $groupedItems[$group->name] = [];

            foreach ($combinedData as $item) {
                if ($item['group_id'] == $group->id) {
                    $groupedItems[$group->name][] = $item;
                }
            }
        }

        $allOpeningStock = 0;

        foreach ($combinedData as $item) {
            $allOpeningStock += $item['obItemTotalClosingRate'];
        }

        $allClosingStock = 0;

        foreach ($combinedData as $item) {
            $allClosingStock += $item['ItemTotalClosingRate'];
        }

        // dd($allClosingStock,$allOpeningStock);

        return [$groupedItems, $groups, $from_date, $to_date, $allClosingStock,$allOpeningStock];
    }
    public function completeStockReportClosingBalanceAndOpeningBalanceForProfitAndLossLedgerReport($request, $from_date, $to_date)
    {
        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $from_date = date("2003-01-01");
        $to_date = date('Y-m-d', strtotime('-1 day', strtotime($to_date)));

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $groups = AdminItemGroup::where('branch_id', session()->get('selected_branch'))->get();

        $itemNames = ItemName::with('unit')->where('branch_id', session()->get('selected_branch'))->get();

        $salesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    // ->groupBy('item_id')
                    ->whereNotNull('invoice_no')
                    ->get();

        $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->whereIn('item_id', $itemNames->pluck('id'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();
        $openingBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->whereIn('item_id', $itemNames->pluck('id'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();

        $purchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();
        $salesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')

                ->get();
            // dd($salesReturnInvoices);
        $obSalesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    // ->groupBy('item_id')
                    ->whereNotNull('invoice_no')
                    ->get();

        $obPurchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();
        $obOpeningBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();
        $obPurchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();
        $obSalesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();

        $originalPurchaseInvoice = $purchaseInvoices->toArray();
        $openingBalanceForInventory = $openingBalanceForInventories->toArray();
        $salesInvoice = $salesInvoices->toArray();
        $purchaseReturn = $purchaseReturnInvoices->toArray();
        $salesReturn = $salesReturnInvoices->toArray();

        $obOriginalPurchaseInvoice = $obPurchaseInvoices->toArray();
        $obOpeningBalanceForInventory = $obOpeningBalanceForInventories->toArray();
        $obSalesInvoice = $obSalesInvoices->toArray();
        $obPurchaseReturn = $obPurchaseReturnInvoices->toArray();
        $obSalesReturn = $obSalesReturnInvoices->toArray();

        // Initialize variables
        $obWorkingSalesInvoices = $obSalesInvoice;

        // Copy original purchase invoices to work with
        $obWorkingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$obOriginalPurchaseInvoice);

        // Initialize arrays to store closing quantities and totals for each item_id
        $itemClosings = [];
        $obItemClosings = [];
        // Group original purchase invoices by item_id
        $obOriginalPurchaseInvoicesByItem = [];
        foreach ($obWorkingOriginalPurchaseInvoice as $purchase) {
            $item_id = $purchase['item_id'];
            if (!isset($obOriginalPurchaseInvoicesByItem[$item_id])) {
                $obOriginalPurchaseInvoicesByItem[$item_id] = [];
            }
            $obOriginalPurchaseInvoicesByItem[$item_id][] = $purchase;
        }

        // Group sales invoices by item_id
        $obSalesInvoicesByItem = [];
        foreach ($obSalesInvoice as $sale) {
            $item_id = $sale['item_id'];
            if (!isset($obSalesInvoicesByItem[$item_id])) {
                $obSalesInvoicesByItem[$item_id] = [];
            }
            $obSalesInvoicesByItem[$item_id][] = $sale;
        }

        // Iterate over each item_id
        foreach ($obOriginalPurchaseInvoicesByItem as $item_id => $purchases) {
            // Initialize closing total and quantity for the current item_id
            $obItemClosings[$item_id]['closingTotal'] = 0;
            $obItemClosings[$item_id]['closingQuantity'] = 0;

            // Calculate total cost and quantity from original purchases
            foreach ($purchases as $purchase) {
                $obItemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
                $obItemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
            }

            // Adjust for sales invoices
            if (isset($obSalesInvoicesByItem[$item_id])) {
                foreach ($obSalesInvoicesByItem[$item_id] as $sale) {
                    $saleQuantity = $sale['quantity'];

                    // Find corresponding original purchase invoices for this sale
                    foreach ($purchases as &$purchase) {
                        $soldQuantity = min($saleQuantity, $purchase['quantity']);
                        $saleQuantity -= $soldQuantity;
                        $purchase['quantity'] -= $soldQuantity;

                        // Update closing total and quantity
                        $obItemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $obItemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

                        if ($saleQuantity <= 0) {
                            break;
                        }
                    }
                }
            }
        }

        $obWorkingSalesReturn = array_merge($obSalesReturn);

        $obWorkingOriginalPurchaseInvoiceForReturns =  array_merge($obOpeningBalanceForInventory,$obOriginalPurchaseInvoice);


        foreach ($obWorkingSalesReturn as $return) {
            $returnedQuantity = $return['quantity'];
            $itemId = $return['item_id'];

            foreach ($obWorkingOriginalPurchaseInvoiceForReturns as &$purchase) {
                if ($purchase['item_id'] === $itemId) {
                    $purchaseQuantity = $purchase['quantity'];

                    $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

                    // Check if the keys exist before accessing them
                    if (isset($obItemClosings[$itemId]['closingTotal']) && isset($obItemClosings[$itemId]['closingQuantity'])) {
                        $obItemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $obItemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;
                    } else {
                        // If the keys don't exist, initialize them
                        $obItemClosings[$itemId]['closingTotal'] = $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $obItemClosings[$itemId]['closingQuantity'] = $returnToPurchaseQuantity;
                    }

                    $purchase['quantity'] -= $returnToPurchaseQuantity;
                    $returnedQuantity -= $returnToPurchaseQuantity;

                    if ($returnedQuantity <= 0) {
                        break;
                    }
                }
            }
        }


        foreach ($obPurchaseReturn as $return) {
            $returnedQuantity = $return['quantity'];

            $item_id = $return['item_id'];
            $obItemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
            $obItemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
        }

        // dd($obItemClosings);

        $workingSalesInvoices = $salesInvoice;

        // $workingOriginalPurchaseInvoice = $originalPurchaseInvoice;
        $workingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        $itemClosings = [];
        $originalPurchaseInvoicesByItem = [];
        foreach ($workingOriginalPurchaseInvoice as $purchase) {
            $item_id = $purchase['item_id'];
            if (!isset($originalPurchaseInvoicesByItem[$item_id])) {
                $originalPurchaseInvoicesByItem[$item_id] = [];
            }
            $originalPurchaseInvoicesByItem[$item_id][] = $purchase;
        }

        $workingSalesInvoice = array_merge($obSalesInvoice, $salesInvoice);

        // Group sales invoices by item_id
        $salesInvoicesByItem = [];
        foreach ($workingSalesInvoice as $sale) {
            $item_id = $sale['item_id'];
            if (!isset($salesInvoicesByItem[$item_id])) {
                $salesInvoicesByItem[$item_id] = [];
            }
            $salesInvoicesByItem[$item_id][] = $sale;
        }

        // Iterate over each item_id
        foreach ($originalPurchaseInvoicesByItem as $item_id => $purchases) {
            // Initialize closing total and quantity for the current item_id
            $itemClosings[$item_id]['closingTotal'] = 0;
            $itemClosings[$item_id]['closingQuantity'] = 0;

            // Calculate total cost and quantity from original purchases
            foreach ($purchases as $purchase) {
                $itemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
                $itemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
            }

            // Adjust for sales invoices
            if (isset($salesInvoicesByItem[$item_id])) {
                foreach ($salesInvoicesByItem[$item_id] as $sale) {
                    $saleQuantity = $sale['quantity'];

                    // Find corresponding original purchase invoices for this sale
                    foreach ($purchases as &$purchase) {
                        $soldQuantity = min($saleQuantity, $purchase['quantity']);
                        $saleQuantity -= $soldQuantity;
                        $purchase['quantity'] -= $soldQuantity;

                        // Update closing total and quantity
                        $itemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $itemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

                        if ($saleQuantity <= 0) {
                            break;
                        }
                    }
                }
            }
        }
        // Copy original purchase invoices to work with for sales returns
        // $workingOriginalPurchaseInvoiceForReturns = $originalPurchaseInvoice;
        $workingOriginalPurchaseInvoiceForReturns = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        $workingSalesReturn = array_merge($obSalesReturn, $salesReturn);

        foreach ($workingSalesReturn as $return) {
            $returnedQuantity = $return['quantity'];
            $itemId = $return['item_id'];

            // Iterate through copied original purchase invoices for returns
            foreach ($workingOriginalPurchaseInvoiceForReturns as &$purchase) {
                // Check if the item_id matches the returned item_id
                if ($purchase['item_id'] === $itemId) {
                    $purchaseQuantity = $purchase['quantity'];

                    // Calculate the quantity to be returned to the original purchase
                    $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

                    // Update closing total using the purchase rate
                    $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);

                    // Update closing quantity
                    $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;

                    // Reduce the quantity of the copied original purchase
                    $purchase['quantity'] -= $returnToPurchaseQuantity;

                    $returnedQuantity -= $returnToPurchaseQuantity;

                    if ($returnedQuantity <= 0) {
                        break; // No need to continue if all returned quantities are processed
                    }
                }
            }
        }

        $workingPurchaseReturn = array_merge($obPurchaseReturn, $purchaseReturn);

        // FIFO logic for debit notes (purchase returns)
        foreach ($workingPurchaseReturn as $return) {
            $returnedQuantity = $return['quantity'];

            // Update closing total and quantity for each returned item
            $item_id = $return['item_id'];
            $itemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
            $itemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
        }

        // // Output the closing quantities and totals for each item_id
        // dd($itemClosings);

        $combinedData = [];

        foreach ($itemNames as $item) {
            $itemId = $item->id;
            $itemName = $item->name;

            // $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0) + (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0);
            // $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) + (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);
            $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0);
            $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) ;

            // $obItemTotalQuantity = (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0) ;
            $obItemTotalRate = (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);

            $combinedData[] = [
                'itemId' => $itemId,
                'itemName' => $itemName,
                'unit' => $item->unit->unit,
                'group_id' => $item->group_id,
                'ItemTotalClosingQuantity' => $itemTotalQuantity,
                'ItemTotalClosingRate' => $itemTotalRate,
                'obItemTotalClosingRate' => $obItemTotalRate,
                'perItemRate' => ($itemTotalQuantity != 0) ? $itemTotalRate / $itemTotalQuantity : 0,

                // 'perItemRate' => ($itemTotalRate != 0) ? $itemTotalRate / $itemTotalQuantity : 0,
            ];
        }

        $groupedItems = [];

        foreach ($groups as $group) {
            $groupedItems[$group->name] = [];

            foreach ($combinedData as $item) {
                if ($item['group_id'] == $group->id) {
                    $groupedItems[$group->name][] = $item;
                }
            }
        }

        $allOpeningStock = 0;

        foreach ($combinedData as $item) {
            $allOpeningStock += $item['obItemTotalClosingRate'];
        }

        $allClosingStock = 0;

        foreach ($combinedData as $item) {
            $allClosingStock += $item['ItemTotalClosingRate'];
        }

        // dd($allClosingStock,$allOpeningStock);

        return [$groupedItems, $groups, $from_date, $to_date, $allClosingStock,$allOpeningStock];
    }

    // public function completeStockReportClosingBalanceAndOpeningBalance($request, $from_date, $to_date)
    // {
    //     $from_date = $request->from_date;
    //     $to_date = $request->to_date;

    //     $currentYearFirstDate = date("2003-01-01");
    //     $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

    //     $groups = AdminItemGroup::where('branch_id', session()->get('selected_branch'))->get();

    //     $itemNames = ItemName::with('unit')->where('branch_id', session()->get('selected_branch'))->get();

    //     $salesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
    //             ->where('date', '>=', $from_date . ' 00:00:00')
    //             ->where('date', '<=', $to_date . ' 23:59:59')
    //             ->whereIn('item_id', $itemNames->pluck('id'))
    //             // ->groupBy('item_id')
    //             // ->whereNotNull('invoice_no')
    //             ->get();

    //     $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
    //         ->whereIn('item_id', $itemNames->pluck('id'))
    //         ->where('date', '>=', $from_date . ' 00:00:00')
    //         ->where('date', '<=', $to_date . ' 23:59:59')
    //         // ->groupBy('item_id')
    //         // ->whereNotNull('invoice_no')
    //         ->orderBy('invoice_no')
    //         ->get();
    //     $openingBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
    //         ->whereIn('item_id', $itemNames->pluck('id'))
    //         ->where('date', '>=', $from_date . ' 00:00:00')
    //         ->where('date', '<=', $to_date . ' 23:59:59')
    //         // ->groupBy('item_id')
    //         // ->whereNotNull('invoice_no')
    //         ->orderBy('invoice_no')
    //         ->get();

    //     $purchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
    //         ->where('date', '>=', $from_date . ' 00:00:00')
    //         ->where('date', '<=', $to_date . ' 23:59:59')
    //         ->whereIn('item_id', $itemNames->pluck('id'))
    //         // ->groupBy('item_id')
    //         // ->whereNotNull('invoice_no')
    //         ->get();
    //     $salesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
    //         ->where('date', '>=', $from_date . ' 00:00:00')
    //         ->where('date', '<=', $to_date . ' 23:59:59')
    //         ->whereIn('item_id', $itemNames->pluck('id'))
    //         // ->groupBy('item_id')
    //         // ->whereNotNull('invoice_no')
    //         ->orderBy('invoice_no')

    //         ->get();
    //         // dd($salesReturnInvoices);
    //     $obSalesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
    //             ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
    //             ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
    //             ->whereIn('item_id', $itemNames->pluck('id'))
    //             // ->groupBy('item_id')
    //             ->whereNotNull('invoice_no')
    //             ->get();

    //     $obPurchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
    //         ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
    //         ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
    //         ->whereIn('item_id', $itemNames->pluck('id'))
    //         // ->groupBy('item_id')
    //         ->whereNotNull('invoice_no')
    //         ->get();
    //     $obOpeningBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
    //         ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
    //         ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
    //         ->whereIn('item_id', $itemNames->pluck('id'))
    //         // ->groupBy('item_id')
    //         // ->whereNotNull('invoice_no')
    //         ->orderBy('invoice_no')
    //         ->get();
    //     $obPurchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
    //         ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
    //         ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
    //         ->whereIn('item_id', $itemNames->pluck('id'))
    //         // ->groupBy('item_id')
    //         ->whereNotNull('invoice_no')
    //         ->get();
    //     $obSalesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
    //         ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
    //         ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
    //         ->whereIn('item_id', $itemNames->pluck('id'))
    //         // ->groupBy('item_id')
    //         ->whereNotNull('invoice_no')
    //         ->get();

    //     $originalPurchaseInvoice = $purchaseInvoices->toArray();
    //     $openingBalanceForInventory = $openingBalanceForInventories->toArray();
    //     $salesInvoice = $salesInvoices->toArray();
    //     $purchaseReturn = $purchaseReturnInvoices->toArray();
    //     $salesReturn = $salesReturnInvoices->toArray();

    //     $obOriginalPurchaseInvoice = $obPurchaseInvoices->toArray();
    //     $obOpeningBalanceForInventory = $obOpeningBalanceForInventories->toArray();
    //     $obSalesInvoice = $obSalesInvoices->toArray();
    //     $obPurchaseReturn = $obPurchaseReturnInvoices->toArray();
    //     $obSalesReturn = $obSalesReturnInvoices->toArray();

    //     // Initialize variables
    //     $obWorkingSalesInvoices = $obSalesInvoice;

    //     // Copy original purchase invoices to work with
    //     $obWorkingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$obOriginalPurchaseInvoice);

    //     // Initialize arrays to store closing quantities and totals for each item_id
    //     $itemClosings = [];
    //     $obItemClosings = [];
    //     // Group original purchase invoices by item_id
    //     $obOriginalPurchaseInvoicesByItem = [];
    //     foreach ($obWorkingOriginalPurchaseInvoice as $purchase) {
    //         $item_id = $purchase['item_id'];
    //         if (!isset($obOriginalPurchaseInvoicesByItem[$item_id])) {
    //             $obOriginalPurchaseInvoicesByItem[$item_id] = [];
    //         }
    //         $obOriginalPurchaseInvoicesByItem[$item_id][] = $purchase;
    //     }

    //     // Group sales invoices by item_id
    //     $obSalesInvoicesByItem = [];
    //     foreach ($obSalesInvoice as $sale) {
    //         $item_id = $sale['item_id'];
    //         if (!isset($obSalesInvoicesByItem[$item_id])) {
    //             $obSalesInvoicesByItem[$item_id] = [];
    //         }
    //         $obSalesInvoicesByItem[$item_id][] = $sale;
    //     }

    //     // Iterate over each item_id
    //     foreach ($obOriginalPurchaseInvoicesByItem as $item_id => $purchases) {
    //         // Initialize closing total and quantity for the current item_id
    //         $obItemClosings[$item_id]['closingTotal'] = 0;
    //         $obItemClosings[$item_id]['closingQuantity'] = 0;

    //         // Calculate total cost and quantity from original purchases
    //         foreach ($purchases as $purchase) {
    //             $obItemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
    //             $obItemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
    //         }

    //         // Adjust for sales invoices
    //         if (isset($obSalesInvoicesByItem[$item_id])) {
    //             foreach ($obSalesInvoicesByItem[$item_id] as $sale) {
    //                 $saleQuantity = $sale['quantity'];

    //                 // Find corresponding original purchase invoices for this sale
    //                 foreach ($purchases as &$purchase) {
    //                     $soldQuantity = min($saleQuantity, $purchase['quantity']);
    //                     $saleQuantity -= $soldQuantity;
    //                     $purchase['quantity'] -= $soldQuantity;

    //                     // Update closing total and quantity
    //                     $obItemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
    //                     $obItemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

    //                     if ($saleQuantity <= 0) {
    //                         break;
    //                     }
    //                 }
    //             }
    //         }
    //     }

    //     $obWorkingSalesReturn = array_merge($obSalesReturn, $salesReturn);

    //     $obWorkingOriginalPurchaseInvoiceForReturns =  array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

    //     // foreach ($obWorkingSalesReturn as $return) {
    //     //     $returnedQuantity = $return['quantity'];
    //     //     $itemId = $return['item_id'];

    //     //     foreach ($obWorkingOriginalPurchaseInvoiceForReturns as &$purchase) {
    //     //         if ($purchase['item_id'] === $itemId) {
    //     //             $purchaseQuantity = $purchase['quantity'];

    //     //             $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

    //     //             $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);

    //     //             $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;

    //     //             $purchase['quantity'] -= $returnToPurchaseQuantity;

    //     //             $returnedQuantity -= $returnToPurchaseQuantity;

    //     //             if ($returnedQuantity <= 0) {
    //     //                 break;
    //     //             }
    //     //         }
    //     //     }
    //     // }

    //     foreach ($obWorkingSalesReturn as $return) {
    //         $returnedQuantity = $return['quantity'];
    //         $itemId = $return['item_id'];

    //         foreach ($obWorkingOriginalPurchaseInvoiceForReturns as &$purchase) {
    //             if ($purchase['item_id'] === $itemId) {
    //                 $purchaseQuantity = $purchase['quantity'];

    //                 $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

    //                 // Check if the keys exist before accessing them
    //                 if (isset($itemClosings[$itemId]['closingTotal']) && isset($itemClosings[$itemId]['closingQuantity'])) {
    //                     $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
    //                     $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;
    //                 } else {
    //                     // If the keys don't exist, initialize them
    //                     $itemClosings[$itemId]['closingTotal'] = $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
    //                     $itemClosings[$itemId]['closingQuantity'] = $returnToPurchaseQuantity;
    //                 }

    //                 $purchase['quantity'] -= $returnToPurchaseQuantity;
    //                 $returnedQuantity -= $returnToPurchaseQuantity;

    //                 if ($returnedQuantity <= 0) {
    //                     break;
    //                 }
    //             }
    //         }
    //     }


    //     foreach ($obPurchaseReturn as $return) {
    //         $returnedQuantity = $return['quantity'];

    //         $item_id = $return['item_id'];
    //         $obItemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
    //         $obItemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
    //     }

    //     // dd($obItemClosings);

    //     $workingSalesInvoices = $salesInvoice;

    //     // $workingOriginalPurchaseInvoice = $originalPurchaseInvoice;
    //     $workingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

    //     $itemClosings = [];
    //     $originalPurchaseInvoicesByItem = [];
    //     foreach ($workingOriginalPurchaseInvoice as $purchase) {
    //         $item_id = $purchase['item_id'];
    //         if (!isset($originalPurchaseInvoicesByItem[$item_id])) {
    //             $originalPurchaseInvoicesByItem[$item_id] = [];
    //         }
    //         $originalPurchaseInvoicesByItem[$item_id][] = $purchase;
    //     }

    //     $workingSalesInvoice = array_merge($obSalesInvoice, $salesInvoice);

    //     // Group sales invoices by item_id
    //     $salesInvoicesByItem = [];
    //     foreach ($workingSalesInvoice as $sale) {
    //         $item_id = $sale['item_id'];
    //         if (!isset($salesInvoicesByItem[$item_id])) {
    //             $salesInvoicesByItem[$item_id] = [];
    //         }
    //         $salesInvoicesByItem[$item_id][] = $sale;
    //     }

    //     // Iterate over each item_id
    //     foreach ($originalPurchaseInvoicesByItem as $item_id => $purchases) {
    //         // Initialize closing total and quantity for the current item_id
    //         $itemClosings[$item_id]['closingTotal'] = 0;
    //         $itemClosings[$item_id]['closingQuantity'] = 0;

    //         // Calculate total cost and quantity from original purchases
    //         foreach ($purchases as $purchase) {
    //             $itemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
    //             $itemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
    //         }

    //         // Adjust for sales invoices
    //         if (isset($salesInvoicesByItem[$item_id])) {
    //             foreach ($salesInvoicesByItem[$item_id] as $sale) {
    //                 $saleQuantity = $sale['quantity'];

    //                 // Find corresponding original purchase invoices for this sale
    //                 foreach ($purchases as &$purchase) {
    //                     $soldQuantity = min($saleQuantity, $purchase['quantity']);
    //                     $saleQuantity -= $soldQuantity;
    //                     $purchase['quantity'] -= $soldQuantity;

    //                     // Update closing total and quantity
    //                     $itemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
    //                     $itemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

    //                     if ($saleQuantity <= 0) {
    //                         break;
    //                     }
    //                 }
    //             }
    //         }
    //     }
    //     // Copy original purchase invoices to work with for sales returns
    //     // $workingOriginalPurchaseInvoiceForReturns = $originalPurchaseInvoice;
    //     $workingOriginalPurchaseInvoiceForReturns = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

    //     $workingSalesReturn = array_merge($obSalesReturn, $salesReturn);

    //     foreach ($workingSalesReturn as $return) {
    //         $returnedQuantity = $return['quantity'];
    //         $itemId = $return['item_id'];

    //         // Iterate through copied original purchase invoices for returns
    //         foreach ($workingOriginalPurchaseInvoiceForReturns as &$purchase) {
    //             // Check if the item_id matches the returned item_id
    //             if ($purchase['item_id'] === $itemId) {
    //                 $purchaseQuantity = $purchase['quantity'];

    //                 // Calculate the quantity to be returned to the original purchase
    //                 $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

    //                 // Update closing total using the purchase rate
    //                 $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);

    //                 // Update closing quantity
    //                 $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;

    //                 // Reduce the quantity of the copied original purchase
    //                 $purchase['quantity'] -= $returnToPurchaseQuantity;

    //                 $returnedQuantity -= $returnToPurchaseQuantity;

    //                 if ($returnedQuantity <= 0) {
    //                     break; // No need to continue if all returned quantities are processed
    //                 }
    //             }
    //         }
    //     }

    //     $workingPurchaseReturn = array_merge($obPurchaseReturn, $purchaseReturn);

    //     // FIFO logic for debit notes (purchase returns)
    //     foreach ($workingPurchaseReturn as $return) {
    //         $returnedQuantity = $return['quantity'];

    //         // Update closing total and quantity for each returned item
    //         $item_id = $return['item_id'];
    //         $itemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
    //         $itemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
    //     }

    //     // // Output the closing quantities and totals for each item_id
    //     // dd($itemClosings);

    //     $combinedData = [];

    //     foreach ($itemNames as $item) {
    //         $itemId = $item->id;
    //         $itemName = $item->name;

    //         // $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0) + (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0);
    //         // $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) + (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);
    //         $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0);
    //         $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) ;

    //         // $obItemTotalQuantity = (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0) ;
    //         $obItemTotalRate = (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);

    //         $combinedData[] = [
    //             'itemId' => $itemId,
    //             'itemName' => $itemName,
    //             'unit' => $item->unit->unit,
    //             'group_id' => $item->group_id,
    //             'ItemTotalClosingQuantity' => $itemTotalQuantity,
    //             'ItemTotalClosingRate' => $itemTotalRate,
    //             'obItemTotalClosingRate' => $obItemTotalRate,
    //             'perItemRate' => ($itemTotalQuantity != 0) ? $itemTotalRate / $itemTotalQuantity : 0,

    //             // 'perItemRate' => ($itemTotalRate != 0) ? $itemTotalRate / $itemTotalQuantity : 0,
    //         ];
    //     }

    //     $groupedItems = [];

    //     foreach ($groups as $group) {
    //         $groupedItems[$group->name] = [];

    //         foreach ($combinedData as $item) {
    //             if ($item['group_id'] == $group->id) {
    //                 $groupedItems[$group->name][] = $item;
    //             }
    //         }
    //     }

    //     $allOpeningStock = 0;

    //     foreach ($combinedData as $item) {
    //         $allOpeningStock += $item['obItemTotalClosingRate'];
    //     }

    //     $allClosingStock = 0;

    //     foreach ($combinedData as $item) {
    //         $allClosingStock += $item['ItemTotalClosingRate'];
    //     }

    //     // dd($allClosingStock,$allOpeningStock);

    //     return [$groupedItems, $groups, $from_date, $to_date, $allClosingStock,$allOpeningStock];


    // }
    public function completeStockReportClosingBalance($request, $from_date, $to_date)
    {
        // $from_date = $request->input('from_date', '');
        // $to_date = $request->input('to_date', '');
        // $from_date = $request->from_date;
        // $to_date = $request->to_date;
        $from_date = $request->old('from_date');
        $to_date = $request->old('to_date');

        // $from_date = $request->from_date;
        // $to_date = $request->to_date;


        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $groups = AdminItemGroup::where('branch_id', session()->get('selected_branch'))->get();

        $itemNames = ItemName::with('unit')->where('branch_id', session()->get('selected_branch'))->get();

        $salesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    // ->groupBy('item_id')
                    // ->whereNotNull('invoice_no')
                    ->get();

        $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->whereIn('item_id', $itemNames->pluck('id'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();
        $openingBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->whereIn('item_id', $itemNames->pluck('id'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();

        $purchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->get();
        $salesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')

                ->get();
            // dd($salesReturnInvoices);
        $obSalesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    // ->groupBy('item_id')
                    ->whereNotNull('invoice_no')
                    ->get();

        $obPurchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();
        $obOpeningBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();
        $obPurchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();
        $obSalesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();

        $originalPurchaseInvoice = $purchaseInvoices->toArray();
        $openingBalanceForInventory = $openingBalanceForInventories->toArray();
        $salesInvoice = $salesInvoices->toArray();
        $purchaseReturn = $purchaseReturnInvoices->toArray();
        $salesReturn = $salesReturnInvoices->toArray();

        $obOriginalPurchaseInvoice = $obPurchaseInvoices->toArray();
        $obOpeningBalanceForInventory = $obOpeningBalanceForInventories->toArray();
        $obSalesInvoice = $obSalesInvoices->toArray();
        $obPurchaseReturn = $obPurchaseReturnInvoices->toArray();
        $obSalesReturn = $obSalesReturnInvoices->toArray();

        // Initialize variables
        $obWorkingSalesInvoices = $obSalesInvoice;

        // Copy original purchase invoices to work with
        $obWorkingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$obOriginalPurchaseInvoice);

        // Initialize arrays to store closing quantities and totals for each item_id
        $itemClosings = [];
        $obItemClosings = [];
        // Group original purchase invoices by item_id
        $obOriginalPurchaseInvoicesByItem = [];
        foreach ($obWorkingOriginalPurchaseInvoice as $purchase) {
            $item_id = $purchase['item_id'];
            if (!isset($obOriginalPurchaseInvoicesByItem[$item_id])) {
                $obOriginalPurchaseInvoicesByItem[$item_id] = [];
            }
            $obOriginalPurchaseInvoicesByItem[$item_id][] = $purchase;
        }

        // Group sales invoices by item_id
        $obSalesInvoicesByItem = [];
        foreach ($obSalesInvoice as $sale) {
            $item_id = $sale['item_id'];
            if (!isset($obSalesInvoicesByItem[$item_id])) {
                $obSalesInvoicesByItem[$item_id] = [];
            }
            $obSalesInvoicesByItem[$item_id][] = $sale;
        }

        // Iterate over each item_id
        foreach ($obOriginalPurchaseInvoicesByItem as $item_id => $purchases) {
            // Initialize closing total and quantity for the current item_id
            $obItemClosings[$item_id]['closingTotal'] = 0;
            $obItemClosings[$item_id]['closingQuantity'] = 0;

            // Calculate total cost and quantity from original purchases
            foreach ($purchases as $purchase) {
                $obItemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
                $obItemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
            }

            // Adjust for sales invoices
            if (isset($obSalesInvoicesByItem[$item_id])) {
                foreach ($obSalesInvoicesByItem[$item_id] as $sale) {
                    $saleQuantity = $sale['quantity'];

                    // Find corresponding original purchase invoices for this sale
                    foreach ($purchases as &$purchase) {
                        $soldQuantity = min($saleQuantity, $purchase['quantity']);
                        $saleQuantity -= $soldQuantity;
                        $purchase['quantity'] -= $soldQuantity;

                        // Update closing total and quantity
                        $obItemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $obItemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

                        if ($saleQuantity <= 0) {
                            break;
                        }
                    }
                }
            }
        }

        $obWorkingSalesReturn = array_merge($obSalesReturn, $salesReturn);

        $obWorkingOriginalPurchaseInvoiceForReturns =  array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        // foreach ($obWorkingSalesReturn as $return) {
        //     $returnedQuantity = $return['quantity'];
        //     $itemId = $return['item_id'];

        //     foreach ($obWorkingOriginalPurchaseInvoiceForReturns as &$purchase) {
        //         if ($purchase['item_id'] === $itemId) {
        //             $purchaseQuantity = $purchase['quantity'];

        //             $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

        //             $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);

        //             $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;

        //             $purchase['quantity'] -= $returnToPurchaseQuantity;

        //             $returnedQuantity -= $returnToPurchaseQuantity;

        //             if ($returnedQuantity <= 0) {
        //                 break;
        //             }
        //         }
        //     }
        // }

        foreach ($obWorkingSalesReturn as $return) {
            $returnedQuantity = $return['quantity'];
            $itemId = $return['item_id'];

            foreach ($obWorkingOriginalPurchaseInvoiceForReturns as &$purchase) {
                if ($purchase['item_id'] === $itemId) {
                    $purchaseQuantity = $purchase['quantity'];

                    $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

                    // Check if the keys exist before accessing them
                    if (isset($itemClosings[$itemId]['closingTotal']) && isset($itemClosings[$itemId]['closingQuantity'])) {
                        $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;
                    } else {
                        // If the keys don't exist, initialize them
                        $itemClosings[$itemId]['closingTotal'] = $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $itemClosings[$itemId]['closingQuantity'] = $returnToPurchaseQuantity;
                    }

                    $purchase['quantity'] -= $returnToPurchaseQuantity;
                    $returnedQuantity -= $returnToPurchaseQuantity;

                    if ($returnedQuantity <= 0) {
                        break;
                    }
                }
            }
        }


        foreach ($obPurchaseReturn as $return) {
            $returnedQuantity = $return['quantity'];

            $item_id = $return['item_id'];
            $obItemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
            $obItemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
        }

        // dd($obItemClosings);

        $workingSalesInvoices = $salesInvoice;

        // $workingOriginalPurchaseInvoice = $originalPurchaseInvoice;
        $workingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        $itemClosings = [];
        $originalPurchaseInvoicesByItem = [];
        foreach ($workingOriginalPurchaseInvoice as $purchase) {
            $item_id = $purchase['item_id'];
            if (!isset($originalPurchaseInvoicesByItem[$item_id])) {
                $originalPurchaseInvoicesByItem[$item_id] = [];
            }
            $originalPurchaseInvoicesByItem[$item_id][] = $purchase;
        }

        $workingSalesInvoice = array_merge($obSalesInvoice, $salesInvoice);

        // Group sales invoices by item_id
        $salesInvoicesByItem = [];
        foreach ($workingSalesInvoice as $sale) {
            $item_id = $sale['item_id'];
            if (!isset($salesInvoicesByItem[$item_id])) {
                $salesInvoicesByItem[$item_id] = [];
            }
            $salesInvoicesByItem[$item_id][] = $sale;
        }

        // Iterate over each item_id
        foreach ($originalPurchaseInvoicesByItem as $item_id => $purchases) {
            // Initialize closing total and quantity for the current item_id
            $itemClosings[$item_id]['closingTotal'] = 0;
            $itemClosings[$item_id]['closingQuantity'] = 0;

            // Calculate total cost and quantity from original purchases
            foreach ($purchases as $purchase) {
                $itemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
                $itemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
            }

            // Adjust for sales invoices
            if (isset($salesInvoicesByItem[$item_id])) {
                foreach ($salesInvoicesByItem[$item_id] as $sale) {
                    $saleQuantity = $sale['quantity'];

                    // Find corresponding original purchase invoices for this sale
                    foreach ($purchases as &$purchase) {
                        $soldQuantity = min($saleQuantity, $purchase['quantity']);
                        $saleQuantity -= $soldQuantity;
                        $purchase['quantity'] -= $soldQuantity;

                        // Update closing total and quantity
                        $itemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $itemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

                        if ($saleQuantity <= 0) {
                            break;
                        }
                    }
                }
            }
        }
        // Copy original purchase invoices to work with for sales returns
        // $workingOriginalPurchaseInvoiceForReturns = $originalPurchaseInvoice;
        $workingOriginalPurchaseInvoiceForReturns = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        $workingSalesReturn = array_merge($obSalesReturn, $salesReturn);

        foreach ($workingSalesReturn as $return) {
            $returnedQuantity = $return['quantity'];
            $itemId = $return['item_id'];

            // Iterate through copied original purchase invoices for returns
            foreach ($workingOriginalPurchaseInvoiceForReturns as &$purchase) {
                // Check if the item_id matches the returned item_id
                if ($purchase['item_id'] === $itemId) {
                    $purchaseQuantity = $purchase['quantity'];

                    // Calculate the quantity to be returned to the original purchase
                    $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

                    // Update closing total using the purchase rate
                    $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);

                    // Update closing quantity
                    $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;

                    // Reduce the quantity of the copied original purchase
                    $purchase['quantity'] -= $returnToPurchaseQuantity;

                    $returnedQuantity -= $returnToPurchaseQuantity;

                    if ($returnedQuantity <= 0) {
                        break; // No need to continue if all returned quantities are processed
                    }
                }
            }
        }

        $workingPurchaseReturn = array_merge($obPurchaseReturn, $purchaseReturn);

        // FIFO logic for debit notes (purchase returns)
        foreach ($workingPurchaseReturn as $return) {
            $returnedQuantity = $return['quantity'];

            // Update closing total and quantity for each returned item
            $item_id = $return['item_id'];
            $itemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
            $itemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
        }

        // // Output the closing quantities and totals for each item_id
        // dd($itemClosings);

        $combinedData = [];

        foreach ($itemNames as $item) {
            $itemId = $item->id;
            $itemName = $item->name;

            // $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0) + (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0);
            // $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) + (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);
            $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0);
            $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) ;

            // $obItemTotalQuantity = (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0) ;
            $obItemTotalRate = (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);

            $combinedData[] = [
                'itemId' => $itemId,
                'itemName' => $itemName,
                'unit' => $item->unit->unit,
                'group_id' => $item->group_id,
                'ItemTotalClosingQuantity' => $itemTotalQuantity,
                'ItemTotalClosingRate' => $itemTotalRate,
                'obItemTotalClosingRate' => $obItemTotalRate,
                'perItemRate' => ($itemTotalQuantity != 0) ? $itemTotalRate / $itemTotalQuantity : 0,

                // 'perItemRate' => ($itemTotalRate != 0) ? $itemTotalRate / $itemTotalQuantity : 0,
            ];
        }

        $groupedItems = [];

        foreach ($groups as $group) {
            $groupedItems[$group->name] = [];

            foreach ($combinedData as $item) {
                if ($item['group_id'] == $group->id) {
                    $groupedItems[$group->name][] = $item;
                }
            }
        }

        $allOpeningStock = 0;

        foreach ($combinedData as $item) {
            $allOpeningStock += $item['obItemTotalClosingRate'];
        }

        $allClosingStock = 0;

        foreach ($combinedData as $item) {
            $allClosingStock += $item['ItemTotalClosingRate'];
        }

        // dd($allClosingStock,$allOpeningStock);

        return [$groupedItems, $groups, $from_date, $to_date, $allClosingStock,$allOpeningStock];


    }
    public function groupStockReportClosingBalance($request, $from_date, $to_date)
    {
        // $from_date = $request->input('from_date', '');
        // $to_date = $request->input('to_date', '');

        // $from_date = $request->old('from_date');
        // $to_date = $request->old('to_date');

        $from_date = $request->from_date;
        $to_date = $request->to_date;

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $groupId = $request->input('group_stock');

        $groupName = AdminItemGroup::where('branch_id', session()->get('selected_branch'))
        ->where('id', $groupId)
        ->value('name');
        // dd($groupId);

        $groups = AdminItemGroup::where('branch_id', session()->get('selected_branch'))->get();

        $itemNames = ItemName::with('unit')->where('branch_id', session()->get('selected_branch'))->get();

        $salesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                    ->where('date', '>=', $from_date . ' 00:00:00')
                    ->where('date', '<=', $to_date . ' 23:59:59')
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    // ->groupBy('item_id')
                    // ->whereNotNull('invoice_no')
                    ->get();

        $purchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->whereIn('item_id', $itemNames->pluck('id'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();
        $openingBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->whereIn('item_id', $itemNames->pluck('id'))
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();

        $purchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->get();
        $salesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $from_date . ' 00:00:00')
                ->where('date', '<=', $to_date . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')

                ->get();
            // dd($salesReturnInvoices);
        $obSalesInvoices = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                    ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                    ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                    ->whereIn('item_id', $itemNames->pluck('id'))
                    // ->groupBy('item_id')
                    ->whereNotNull('invoice_no')
                    ->get();

        $obPurchaseInvoices = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();
        $obOpeningBalanceForInventories = OpeningBalance::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                // ->whereNotNull('invoice_no')
                ->orderBy('invoice_no')
                ->get();
        $obPurchaseReturnInvoices = DebitNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();
        $obSalesReturnInvoices = CreditNote::where('branch_id', session()->get('selected_branch'))
            ->whereNull('deleted_at')
                ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
                ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
                ->whereIn('item_id', $itemNames->pluck('id'))
                // ->groupBy('item_id')
                ->whereNotNull('invoice_no')
                ->get();

        $originalPurchaseInvoice = $purchaseInvoices->toArray();
        $openingBalanceForInventory = $openingBalanceForInventories->toArray();
        $salesInvoice = $salesInvoices->toArray();
        $purchaseReturn = $purchaseReturnInvoices->toArray();
        $salesReturn = $salesReturnInvoices->toArray();

        $obOriginalPurchaseInvoice = $obPurchaseInvoices->toArray();
        $obOpeningBalanceForInventory = $obOpeningBalanceForInventories->toArray();
        $obSalesInvoice = $obSalesInvoices->toArray();
        $obPurchaseReturn = $obPurchaseReturnInvoices->toArray();
        $obSalesReturn = $obSalesReturnInvoices->toArray();

        // Initialize variables
        $obWorkingSalesInvoices = $obSalesInvoice;

        // Copy original purchase invoices to work with
        $obWorkingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$obOriginalPurchaseInvoice);

        // Initialize arrays to store closing quantities and totals for each item_id
        $itemClosings = [];
        $obItemClosings = [];
        // Group original purchase invoices by item_id
        $obOriginalPurchaseInvoicesByItem = [];
        foreach ($obWorkingOriginalPurchaseInvoice as $purchase) {
            $item_id = $purchase['item_id'];
            if (!isset($obOriginalPurchaseInvoicesByItem[$item_id])) {
                $obOriginalPurchaseInvoicesByItem[$item_id] = [];
            }
            $obOriginalPurchaseInvoicesByItem[$item_id][] = $purchase;
        }

        // Group sales invoices by item_id
        $obSalesInvoicesByItem = [];
        foreach ($obSalesInvoice as $sale) {
            $item_id = $sale['item_id'];
            if (!isset($obSalesInvoicesByItem[$item_id])) {
                $obSalesInvoicesByItem[$item_id] = [];
            }
            $obSalesInvoicesByItem[$item_id][] = $sale;
        }

        // Iterate over each item_id
        foreach ($obOriginalPurchaseInvoicesByItem as $item_id => $purchases) {
            // Initialize closing total and quantity for the current item_id
            $obItemClosings[$item_id]['closingTotal'] = 0;
            $obItemClosings[$item_id]['closingQuantity'] = 0;

            // Calculate total cost and quantity from original purchases
            foreach ($purchases as $purchase) {
                $obItemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
                $obItemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
            }

            // Adjust for sales invoices
            if (isset($obSalesInvoicesByItem[$item_id])) {
                foreach ($obSalesInvoicesByItem[$item_id] as $sale) {
                    $saleQuantity = $sale['quantity'];

                    // Find corresponding original purchase invoices for this sale
                    foreach ($purchases as &$purchase) {
                        $soldQuantity = min($saleQuantity, $purchase['quantity']);
                        $saleQuantity -= $soldQuantity;
                        $purchase['quantity'] -= $soldQuantity;

                        // Update closing total and quantity
                        $obItemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $obItemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

                        if ($saleQuantity <= 0) {
                            break;
                        }
                    }
                }
            }
        }

        $obWorkingSalesReturn = array_merge($obSalesReturn, $salesReturn);

        $obWorkingOriginalPurchaseInvoiceForReturns =  array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        // foreach ($obWorkingSalesReturn as $return) {
        //     $returnedQuantity = $return['quantity'];
        //     $itemId = $return['item_id'];

        //     foreach ($obWorkingOriginalPurchaseInvoiceForReturns as &$purchase) {
        //         if ($purchase['item_id'] === $itemId) {
        //             $purchaseQuantity = $purchase['quantity'];

        //             $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

        //             $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);

        //             $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;

        //             $purchase['quantity'] -= $returnToPurchaseQuantity;

        //             $returnedQuantity -= $returnToPurchaseQuantity;

        //             if ($returnedQuantity <= 0) {
        //                 break;
        //             }
        //         }
        //     }
        // }

        foreach ($obWorkingSalesReturn as $return) {
            $returnedQuantity = $return['quantity'];
            $itemId = $return['item_id'];

            foreach ($obWorkingOriginalPurchaseInvoiceForReturns as &$purchase) {
                if ($purchase['item_id'] === $itemId) {
                    $purchaseQuantity = $purchase['quantity'];

                    $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

                    // Check if the keys exist before accessing them
                    if (isset($itemClosings[$itemId]['closingTotal']) && isset($itemClosings[$itemId]['closingQuantity'])) {
                        $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;
                    } else {
                        // If the keys don't exist, initialize them
                        $itemClosings[$itemId]['closingTotal'] = $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $itemClosings[$itemId]['closingQuantity'] = $returnToPurchaseQuantity;
                    }

                    $purchase['quantity'] -= $returnToPurchaseQuantity;
                    $returnedQuantity -= $returnToPurchaseQuantity;

                    if ($returnedQuantity <= 0) {
                        break;
                    }
                }
            }
        }


        foreach ($obPurchaseReturn as $return) {
            $returnedQuantity = $return['quantity'];

            $item_id = $return['item_id'];
            $obItemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
            $obItemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
        }

        // dd($obItemClosings);

        $workingSalesInvoices = $salesInvoice;

        // $workingOriginalPurchaseInvoice = $originalPurchaseInvoice;
        $workingOriginalPurchaseInvoice = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        $itemClosings = [];
        $originalPurchaseInvoicesByItem = [];
        foreach ($workingOriginalPurchaseInvoice as $purchase) {
            $item_id = $purchase['item_id'];
            if (!isset($originalPurchaseInvoicesByItem[$item_id])) {
                $originalPurchaseInvoicesByItem[$item_id] = [];
            }
            $originalPurchaseInvoicesByItem[$item_id][] = $purchase;
        }

        $workingSalesInvoice = array_merge($obSalesInvoice, $salesInvoice);

        // Group sales invoices by item_id
        $salesInvoicesByItem = [];
        foreach ($workingSalesInvoice as $sale) {
            $item_id = $sale['item_id'];
            if (!isset($salesInvoicesByItem[$item_id])) {
                $salesInvoicesByItem[$item_id] = [];
            }
            $salesInvoicesByItem[$item_id][] = $sale;
        }

        // Iterate over each item_id
        foreach ($originalPurchaseInvoicesByItem as $item_id => $purchases) {
            // Initialize closing total and quantity for the current item_id
            $itemClosings[$item_id]['closingTotal'] = 0;
            $itemClosings[$item_id]['closingQuantity'] = 0;

            // Calculate total cost and quantity from original purchases
            foreach ($purchases as $purchase) {
                $itemClosings[$item_id]['closingTotal'] += $purchase['quantity'] * ($purchase['rate_unit'] + $purchase['c_f']);
                $itemClosings[$item_id]['closingQuantity'] += $purchase['quantity'];
            }

            // Adjust for sales invoices
            if (isset($salesInvoicesByItem[$item_id])) {
                foreach ($salesInvoicesByItem[$item_id] as $sale) {
                    $saleQuantity = $sale['quantity'];

                    // Find corresponding original purchase invoices for this sale
                    foreach ($purchases as &$purchase) {
                        $soldQuantity = min($saleQuantity, $purchase['quantity']);
                        $saleQuantity -= $soldQuantity;
                        $purchase['quantity'] -= $soldQuantity;

                        // Update closing total and quantity
                        $itemClosings[$item_id]['closingTotal'] -= $soldQuantity * ($purchase['rate_unit'] + $purchase['c_f']);
                        $itemClosings[$item_id]['closingQuantity'] -= $soldQuantity;

                        if ($saleQuantity <= 0) {
                            break;
                        }
                    }
                }
            }
        }
        // Copy original purchase invoices to work with for sales returns
        // $workingOriginalPurchaseInvoiceForReturns = $originalPurchaseInvoice;
        $workingOriginalPurchaseInvoiceForReturns = array_merge($obOpeningBalanceForInventory,$openingBalanceForInventory,$obOriginalPurchaseInvoice, $originalPurchaseInvoice);

        $workingSalesReturn = array_merge($obSalesReturn, $salesReturn);

        foreach ($workingSalesReturn as $return) {
            $returnedQuantity = $return['quantity'];
            $itemId = $return['item_id'];

            // Iterate through copied original purchase invoices for returns
            foreach ($workingOriginalPurchaseInvoiceForReturns as &$purchase) {
                // Check if the item_id matches the returned item_id
                if ($purchase['item_id'] === $itemId) {
                    $purchaseQuantity = $purchase['quantity'];

                    // Calculate the quantity to be returned to the original purchase
                    $returnToPurchaseQuantity = min($returnedQuantity, $purchaseQuantity);

                    // Update closing total using the purchase rate
                    $itemClosings[$itemId]['closingTotal'] += $returnToPurchaseQuantity * ($purchase['rate_unit'] + $purchase['c_f']);

                    // Update closing quantity
                    $itemClosings[$itemId]['closingQuantity'] += $returnToPurchaseQuantity;

                    // Reduce the quantity of the copied original purchase
                    $purchase['quantity'] -= $returnToPurchaseQuantity;

                    $returnedQuantity -= $returnToPurchaseQuantity;

                    if ($returnedQuantity <= 0) {
                        break; // No need to continue if all returned quantities are processed
                    }
                }
            }
        }

        $workingPurchaseReturn = array_merge($obPurchaseReturn, $purchaseReturn);

        // FIFO logic for debit notes (purchase returns)
        foreach ($workingPurchaseReturn as $return) {
            $returnedQuantity = $return['quantity'];

            // Update closing total and quantity for each returned item
            $item_id = $return['item_id'];
            $itemClosings[$item_id]['closingTotal'] -= $returnedQuantity * $return['rate_unit'];
            $itemClosings[$item_id]['closingQuantity'] -= $returnedQuantity;
        }

        // // Output the closing quantities and totals for each item_id
        // dd($itemClosings);

        $combinedData = [];

        foreach ($itemNames as $item) {
            $itemId = $item->id;
            $itemName = $item->name;

            // $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0) + (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0);
            // $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) + (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);
            $itemTotalQuantity = (isset($itemClosings[$itemId]['closingQuantity']) ? $itemClosings[$itemId]['closingQuantity'] : 0);
            $itemTotalRate = (isset($itemClosings[$itemId]['closingTotal']) ? $itemClosings[$itemId]['closingTotal'] : 0) ;

            // $obItemTotalQuantity = (isset($obItemClosings[$itemId]['closingQuantity']) ? $obItemClosings[$itemId]['closingQuantity'] : 0) ;
            $obItemTotalRate = (isset($obItemClosings[$itemId]['closingTotal']) ? $obItemClosings[$itemId]['closingTotal'] : 0);

            $combinedData[] = [
                'itemId' => $itemId,
                'itemName' => $itemName,
                'unit' => $item->unit->unit,
                'group_id' => $item->group_id,
                'ItemTotalClosingQuantity' => $itemTotalQuantity,
                'ItemTotalClosingRate' => $itemTotalRate,
                'obItemTotalClosingRate' => $obItemTotalRate,
                'perItemRate' => ($itemTotalQuantity != 0) ? $itemTotalRate / $itemTotalQuantity : 0,

                // 'perItemRate' => ($itemTotalRate != 0) ? $itemTotalRate / $itemTotalQuantity : 0,
            ];
        }


        $groupedItems = [];

        foreach ($groups as $group) {
            if ($group->id == $groupId) {
                $groupedItems[$group->name] = [];

                foreach ($combinedData as $item) {
                    if ($item['group_id'] == $group->id) {
                        $groupedItems[$group->name][] = $item;
                    }
                }

                break;
            }
        }

        $allOpeningStock = 0;

        foreach ($combinedData as $item) {
            $allOpeningStock += $item['obItemTotalClosingRate'];
        }

        $allClosingStock = 0;

        foreach ($combinedData as $item) {
            $allClosingStock += $item['ItemTotalClosingRate'];
        }






        // dd($allClosingStock,$allOpeningStock);

        return [$groupedItems, $groupName, $from_date, $to_date,];


    }
}
