<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class StaffAndSalesman extends Model
{
    use SoftDeletes;

    // RELATIONS
    public function country()
    {
        return $this->belongsTo(Country::class, 'country_id', 'id');
    }

    public function classOfAccount()
    {
        return $this->belongsTo(ClassOfAccount::class, 'class_of_account_id', 'id');
    }
    //
    //
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'staff_and_salesmen';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'location_id',
        'transactions_password',
        'job_designation',
        'job_title',
        'commission',
        'report_password',
        'date_of_joining',
        'first_name',
        'last_name',
        'mobile_1',
        'mobile_2',
        'whatsapp',
        'email',
        'country_id',
        'city',
        'address',
        'salary',
        'class_of_account_id',
        'show_user',
        'maintain_account',
        'doc_name_1',
        'doc_file_1',
        'doc_expiry_1',
        'doc_name_2',
        'doc_file_2',
        'doc_expiry_2',
        'doc_name_3',
        'doc_file_3',
        'doc_expiry_3',
        'doc_name_4',
        'doc_file_4',
        'doc_expiry_4',
        'doc_name_5',
        'doc_file_5',
        'doc_expiry_5',
        'doc_name_6',
        'doc_file_6',
        'doc_expiry_6',
        'doc_name_7',
        'doc_file_7',
        'doc_expiry_7',
        'description'
    ];


    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
    ];
}
