<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateAdminPaymentVouchersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('admin_payment_vouchers', function (Blueprint $table) {
            $table->id();
            $table->bigInteger('branch_id')->nullable();
            $table->string('invoice_no')->nullable();
            $table->date('date')->nullable();
            $table->enum('payment_method', ['cash', 'bank'])->nullable();
            $table->unsignedBigInteger('bank_id')->nullable();
            $table->string('cheaque_no')->nullable();
            $table->date('cheaque_date')->nullable();
            $table->string('bank_name')->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('admin_payment_vouchers');
    }
}
