<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateOtherAccountBuyersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('other_account_buyers', function (Blueprint $table) {
            $table->id();
            $table->enum('type', ['delivery_note', 'credit_note', 'debit_note', 'journal_voucher', 'payment_voucher', 'purchase_order', 'purchase_invoice', 'quotation', 'receipt_voucher', 'sales_invoice']);
            $table->string('invoice_id');
            $table->string('name')->nullable();
            $table->string('phone')->nullable();
            $table->string('email')->nullable();
            $table->string('vat_number')->nullable();
            $table->string('address')->nullable();
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('other_account_buyers');
    }
}
