@extends('layouts.crusher')
@section('content')


        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Edit Item Name Master</h6>
                            </div>
                        </div>
                        <form action="{{ route('software.item_names.update', ['item_name' => request()->item_name]) }}"
                            class="outer-repeater" method="POST">
                            @csrf
                            @method('put')
                            <div data-repeater-list="outer-group" class="outer">
                                <div data-repeater-item class="outer">
                                    <div class="row">
                                        <div class="inner-repeater col-md-12 md-12">
                                            <div data-repeater-list="inner-group" class="inner form-group">
                                                <div data-repeater-item class="inner mb-3 row">
                                                    <div class="col-md-3 col-3">
                                                        <label>Item Group :</label>
                                                        <select class="form-control select2" name="group_id">
                                                            <option>Select Item Group</option>
                                                            @forelse ($itemGroups as $group)
                                                                <option value="{{ $group->id }}"
                                                                    {{ $itemName->group_id == $group->id ? 'selected' : '' }}>
                                                                    {{ $group->name }}
                                                                </option>
                                                            @empty
                                                            @endforelse
                                                        </select>
                                                    </div>
                                                    <div class="col-md-3 col-3">
                                                        <label>Item Name :</label>
                                                        <textarea name="name" class="form-control" rows="1" type="text" placeholder="Enter Item Name"
                                                            id="example-textarea-input">{{ $itemName->name }}</textarea>
                                                    </div>
                                                    <div class="col-md-2 col-2">
                                                        <label>Item Unit :</label>
                                                        <select class="form-control select2" name="unit_id">
                                                            <option>Select Item Unit</option>
                                                            @forelse ($itemUnits as $unit)
                                                                <option value="{{ $unit->id }}"
                                                                    {{ $itemName->unit_id == $unit->id ? 'selected' : '' }}>
                                                                    {{ $unit->unit }}
                                                                </option>
                                                            @empty
                                                            @endforelse
                                                        </select>
                                                    </div>
                                                    <div class="col-md-2 col-2">
                                                        <label>Vat %:</label>
                                                        <input type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" class="inner form-control" placeholder="Vat %"
                                                            name="vat_percent" step="0.01" min="0"
                                                            value="{{ $itemName->vat_percent }}" />
                                                    </div>
                                                    <div class="col-md-2 col-2">
                                                        <label>Reorder QTY</label>
                                                        <input type="text" class="inner form-control" placeholder="QTY"
                                                            name="quantity" value="{{ $itemName->quantity }}" />
                                                    </div>

                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <button class="btn btn-cust1 float-right" data-toggle="modal" type="submit">Update Item
                                        Name</button>
                                </div>
                            </div>
                        </form>

                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->
@endsection
