@extends('layouts.crusher')
@section('content')

    <div class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-body">
                    <div class="row">
                        <div class="col-md-6">
                            <h6 class="card-title mb-4 titlcust">Group Stock Report
                            </h6>
                            <h6 class="">Date: <span>{{ date('d/m,Y', strtotime($from_date)) }}
                            </span> To <span>{{ date('d/m,Y', strtotime($to_date)) }}</span>
                            </h6>

                        </div>

                    </div>
                    <!-- <div class="col-4"> -->
                    <div class="row">

                        <div class="col-md-6">
                            <h6 class="">Group Name : <span>{{ $groupName }}</span></h6>
                        </div>
                        <div class="col-md-6">
                            <div class="btn-group float-right" role="group" aria-label="Basic example">
                                <a href="" type="button" class="btn btn-outline-primary"><i
                                        class="fas fa-mail-bulk"></i> Email (PDF Formate)</a>
                                <a onclick="printPageArea('printableArea')" class="btn btn-outline-primary"> Print & PDF
                                    Formate</a>

                            </div>
                        </div>
                    </div>
                    <br>
                    <div id="printableArea" class="table-responsive mb-0" data-pattern="priority-columns">
                        <table id="" class="table table-bordered dt-responsive nowrap"
                        style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                        <thead>
                            <tr>
                                <th class="text-center">Item Name</th>
                                <th class="text-center">QTY</th>
                                <th class="text-center">Unit</th>
                                <th class="text-center">Rate</th>
                                <th class="text-center">Value</th>
                            </tr>
                        </thead>
                        @php
                            $TotalQuantity = null;
                            $TotalRateUnit = null;
                            $TotalNetAmount = null;
                        @endphp
                        <tbody>


                            @php
                            $grandTotal = 0;
                            @endphp

                            @foreach ($groupedItems as $groupName => $items)
                            @php
                                $groupTotal = 0;
                                $groupTotalNetAmount = 0;
                            @endphp

                            @foreach ($items as $item)
                                @if($item['ItemTotalClosingQuantity'] > 0)
                                    @php
                                        $groupTotal += $item['ItemTotalClosingQuantity'];
                                        $grandTotal += $item['ItemTotalClosingQuantity'];
                                        $groupTotalNetAmount += $item['ItemTotalClosingQuantity'] * $item['perItemRate'];
                                    @endphp
                                @endif
                            @endforeach

                            @if($groupTotal > 0)
                                <tr>
                                    <td colspan="5" class="text-center"><strong>{{ $groupName }}</strong></td>
                                </tr>

                                @foreach ($items as $item)
                                    @if($item['ItemTotalClosingQuantity'] > 0)
                                        <tr>
                                            <td>{{ $item['itemName'] }}</td>
                                            <td>{{ $item['ItemTotalClosingQuantity'] }}</td>
                                            <td>{{ $item['unit'] }}</td>
                                            <td>{{ number_format($item['perItemRate'], session('branch')->currency_decimal) }}</td>
                                            <td>{{ number_format($item['ItemTotalClosingRate'], session('branch')->currency_decimal) }}</td>
                                            @php
                                                $TotalQuantity += $item['ItemTotalClosingQuantity'];
                                                $TotalRateUnit += $item['ItemTotalClosingRate'];
                                                $TotalNetAmount += $item['ItemTotalClosingQuantity'] * $item['perItemRate'];
                                            @endphp
                                        </tr>
                                    @endif
                                @endforeach

                                <tr class="td-drak-light">
                                    <td><strong>Total: {{ $groupName }}</strong></td>
                                    <td><strong>{{ $groupTotal }}</strong></td>
                                    <td></td>
                                    <td></td>
                                    <td><strong>{{ number_format($groupTotalNetAmount, session('branch')->currency_decimal) }}</strong></td>
                                </tr>
                            @endif
                            @endforeach

                            <tr>
                                <td colspan="5"></td>
                            </tr>
                            <tr class="td-drak-bg">
                                <td><strong>Grand Total</strong></td>
                                <td colspan="3"><strong>{{$TotalQuantity}}</strong></td>
                                <td><strong>{{ number_format($TotalNetAmount, session('branch')->currency_decimal) }}</strong></td>
                            </tr>

                        </tbody>
                    </table>
                    </div>

                    {{-- <br>
                    <div class="row">
                        <div class="col-md-4">
                        </div>
                        <div class="col-md-4">
                        </div>
                        <div class="col-md-4">
                            <div class="row">
                                <div class="col-md-6">
                                </div>
                                <div class="col-md-6">
                                    <p>Total Remaining Quantity : <span>0</span></p>
                                    <p>Total Remaining Value  : <span>0.000</span></p>

                                </div>
                            </div>
                        </div>
                    </div> --}}
                </div>
            </div>
        </div>
    </div>
</div>
<!-- end row -->

<script>
    function printPageArea(areaID) {
        var printContent = document.getElementById(areaID).innerHTML;
        var originalContent = document.body.innerHTML;
        document.body.innerHTML = printContent;
        window.print();
        document.body.innerHTML = originalContent;
    }
</script>


@endsection
