@extends('layouts.crusher')
@section('content')
@php
    use App\Branches;
    use Carbon\Carbon;

    $selectedBranchId = session('selected_branch');

    $branche = Branches::where('id', $selectedBranchId)->first();

@endphp

        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Warehouse Transfer</h6>
                            </div>
                            <div class="col-md-6">
                                <a href="{{ route("software.warehouse_transfers.create") }}">
                                    <button class="btn btn-cust1 float-right" type="submit">Create
                                        Warehouse Transfer</button>
                                </a>
                            </div>
                        </div>
                        <!-- <div class="col-4"> -->


                        <div class="table-responsive mb-0" data-pattern="priority-columns">
                            <table id="datatable" class="table table-bordered nowrap"
                                style="border-collapse: collapse; border-spacing: 0; width: 100%;">
                                <thead>
                                    <tr>
                                        <th>Date</th>
                                        <th>Warehouse Transfer Number</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>

                                <tbody>
                                    @forelse ($warehouseTransfers as $transfer)
                                        {{-- @dd($transfer)     --}}
                                        <tr>
                                            <td>{{ $transfer->date }}</td>
                                            <td>{{ $transfer->invoice_no }}</td>
                                            <td>
                                                @if (
                                                    !empty(($branchId = session()->get('selected_branch'))) &&
                                                        Branches::hasBranchPermission($branchId, 'view-print-warehouse-transfer'))
                                                    <a
                                                        href="{{ route('software.warehouse_transfers.show', ['warehouse_transfer' => $transfer->id]) }}">
                                                        <i class="far fa-eye cust-icon2"></i></a>
                                                @endif

                                                    @if (!$transfer->trashed())
                                                        @if (
                                                            !empty(($branchId = session()->get('selected_branch'))) &&
                                                                Branches::hasBranchPermission($branchId, 'edit-warehouse-transfer'))
                                                            <a
                                                                href="{{ route('software.warehouse_transfers.edit', ['warehouse_transfer' => $transfer->id]) }}">
                                                                <i class="far fa-edit cust-icon2"></i></a>
                                                        @endif

                                                        @if (
                                                            !empty(($branchId = session()->get('selected_branch'))) &&
                                                                Branches::hasBranchPermission($branchId, 'cancel-warehouse-transfer'))

                                                            <form
                                                                action="{{ route('software.warehouse_transfers.delete', ['warehouse_transfer' => $transfer->invoice_no]) }}"
                                                                method="POST" class="d-inline">
                                                                @csrf
                                                                @method('DELETE')
                                                                <input type="hidden" name="invoice_no" value="{{$transfer->invoice_no}}">
                                                                <button onclick="return confirm('Sure want to delete?')" type="submit"
                                                                    class="btn btn-link p-0 m-0 text-danger">
                                                                    <i class="far fa-window-close cust-icon2"></i>
                                                                </button>
                                                            </form>
                                                        @endif


                                                    @else
                                                    <span class="text-danger">Deleted</span>
                                                    @endif
                                            </td>
                                        </tr>
                                    @empty
                                    @endforelse
                                </tbody>
                            </table>
                        </div>


                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->
@endsection
