<?php $__env->startSection('content'); ?>


        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6">
                                <h6 class="card-title mb-4 titlcust">Supplier Master</h6>
                            </div>

                        </div>
                        <!-- <div class="col-4"> -->
                        <form action="<?php echo e(route('software.suppliers.update', ['supplier' => request()->supplier])); ?>"
                            class="outer-repeater" method="POST" enctype="multipart/form-data">
                            <?php echo csrf_field(); ?>
                            <div class="row">

                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label>Account Opening Balance</label>
                                        <?php if(auth()->user()->role=='subadmin'): ?>
                                            <input name="opening_balance"
                                            value="<?php echo e(old('opening_balance', $supplier->opening_balance)); ?>"
                                            class="form-control" type="text" placeholder="Account Opening Balance"
                                            id="example-password-input" disabled>
                                        <?php else: ?>
                                            <input name="opening_balance"
                                            value="<?php echo e(old('opening_balance', $supplier->opening_balance)); ?>"
                                            class="form-control" type="text" placeholder="Account Opening Balance"
                                            id="example-password-input">
                                        <?php endif; ?>

                                        <?php if($errors->has('opening_balance')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('opening_balance')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-3">
                                    <div class="form-group">
                                        <label class="control-label">Debit/Credit</label>
                                        <select class="form-control select2" name="type">
                                            <option value="">Select Debit/Credit</option>
                                            <option value="Debit" <?php if(old('type', $supplier->type) == 'Debit'): ?> selected <?php endif; ?>>Debit
                                            </option>
                                            <option value="Credit" <?php if(old('type', $supplier->type) == 'Credit'): ?> selected <?php endif; ?>>Credit
                                            </option>
                                        </select>
                                        <?php if($errors->has('type')): ?>
                                            <span class="text-danger"><?php echo e($errors->first('type')); ?></span>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label>Date</label>
                                        <input name="date" value="<?php echo e(old('date', $supplier->date)); ?>"
                                            class="form-control" type="date" pattern="\d{4}-\d{2}-\d{2}">
                                        <?php if($errors->has('date')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('date')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-12">
                                    <div class="form-group">
                                        <label>Account Name</label>
                                        <input name="name_of_organisation"
                                            value="<?php echo e(old('name_of_organisation', $supplier->name_of_organisation)); ?>"
                                            class="form-control" type="text" placeholder="Enter Account Name"
                                            id="example-text-input">
                                        <?php if($errors->has('name_of_organisation')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('name_of_organisation')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label>Commercial Registration #</label>
                                        <input name="commerical_registration_number"
                                            value="<?php echo e(old('commerical_registration_number', $supplier->commerical_registration_number)); ?>"
                                            class="form-control" type="text" oninput="this.value = this.value.replace(/[^a-zA-Z0-9]/g, '');" placeholder="Enter Number or Text"
                                            id="example-text-input">
                                        <?php if($errors->has('commerical_registration_number')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('commerical_registration_number')); ?>

                                            </div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label>Contact Person Name</label>
                                        <input name="contact_person_name"
                                            value="<?php echo e(old('contact_person_name', $supplier->contact_person_name)); ?>"
                                            class="form-control" type="text" placeholder="Enter Contact Person Name"
                                            id="example-text-input">
                                        <?php if($errors->has('contact_person_name')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('contact_person_name')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label>Office Phone #</label>
                                        <input name="office_phone"
                                            value="<?php echo e(old('office_phone', $supplier->office_phone)); ?>" class="form-control"
                                            type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Enter Number" id="example-text-input">
                                        <?php if($errors->has('office_phone')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('office_phone')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label>Mobile #</label>
                                        <input name="mobile" value="<?php echo e(old('mobile', $supplier->mobile)); ?>"
                                            class="form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Enter Number"
                                            id="example-text-input">
                                        <?php if($errors->has('mobile')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('mobile')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label>Whatsapp #</label>
                                        <input name="whatsapp" value="<?php echo e(old('whatsapp', $supplier->whatsapp)); ?>"
                                            class="form-control" type="text" oninput="this.value = this.value.replace(/[^0-9.]/g, '');" placeholder="Enter Number"
                                            id="example-text-input">
                                        <?php if($errors->has('whatsapp')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('whatsapp')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label>Email</label>
                                        <input name="email" value="<?php echo e(old('email', $supplier->email)); ?>"
                                            class="form-control" type="email" placeholder="Enter Email"
                                            id="example-text-input">
                                        <?php if($errors->has('email')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('email')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label">Country</label>
                                        <select class="form-control select2" name="country_id">
                                            <option value="">Select Country</option>
                                            <?php $__empty_1 = true; $__currentLoopData = $countries; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $country): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); $__empty_1 = false; ?>
                                                <option value="<?php echo e($country->id); ?>"
                                                    <?php if(old('country_id', $supplier->country_id) == $country->id): ?> selected <?php endif; ?>>
                                                    <?php echo e($country->name); ?></option>
                                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); if ($__empty_1): ?>
                                            <?php endif; ?>
                                        </select>
                                        <?php if($errors->has('country_id')): ?>
                                            <span class="text-danger"><?php echo e($errors->first('country_id')); ?></span>
                                        <?php endif; ?>
                                    </div>
                                </div>



                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label>City</label>
                                        <input name="city" value="<?php echo e(old('city', $supplier->city)); ?>"
                                            class="form-control" type="text" placeholder="Enter Number"
                                            id="example-text-input">
                                        <?php if($errors->has('city')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('city')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-12">
                                    <div class="form-group">
                                        <label>Address</label>
                                        <textarea name="address" class="form-control" rows="2" type="text" placeholder="Enter Address"
                                            id="example-textarea-input"><?php echo e(old('address', $supplier->address)); ?>

                                    </textarea>
                                        <?php if($errors->has('address')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('address')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>

                                <div class="col-md-6">
                                    <div class="form-group">
                                        <label class="control-label">Class Of Account</label>
                                        <select class="form-control select2" name="class_of_account_id">
                                            <option>Select Class of Account</option>
                                            <?php $__empty_1 = true; $__currentLoopData = $classOfAccount; $__env->addLoop($__currentLoopData); foreach($__currentLoopData as $account): $__env->incrementLoopIndices(); $loop = $__env->getLastLoop(); $__empty_1 = false; ?>
                                                <option value="<?php echo e($account->id); ?>"
                                                    <?php if(old('class_of_account_id', $supplier->class_of_account_id) == $account->id): ?> selected <?php endif; ?>>
                                                    <?php echo e($account->name); ?></option>
                                            <?php endforeach; $__env->popLoop(); $loop = $__env->getLastLoop(); if ($__empty_1): ?>
                                            <?php endif; ?>
                                        </select>
                                        <?php if($errors->has('class_of_account_id')): ?>
                                            <div class="text-danger"><?php echo e($errors->first('class_of_account_id')); ?></div>
                                        <?php endif; ?>
                                    </div>
                                </div>


                                <!-- <div class="col-md-6">
                                                                    <div class="form-group">
                                                                        <label class="control-label">Show User</label>
                                                                        <select class="form-control select2">
                                                                            <option>Nothing Selected</option>
                                                                            <option>lorem</option>
                                                                            <option>Lorem</option>
                                                                        </select>
                                                                    </div>
                                                                </div> -->

                                

                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label>VAT Number</label>
                                        <input name="vat_number"
                                            class="form-control <?php $__errorArgs = ['vat_number'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>" type="text"
                                            placeholder="Enter VAT Number"
                                            value="<?php echo e(old('vat_number', $supplier->vat_number)); ?>" id="vat_number">
                                        <?php $__errorArgs = ['vat_number'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                            <div class="invalid-feedback"><?php echo e($message); ?></div>
                                        <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label>TRN Number</label>
                                        <input name="trn_number"
                                            class="form-control <?php $__errorArgs = ['trn_number'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>" type="text"
                                            placeholder="Enter TRN Number"
                                            value="<?php echo e(old('trn_number', $supplier->trn_number)); ?>" id="trn_number">
                                        <?php $__errorArgs = ['trn_number'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                            <div class="invalid-feedback"><?php echo e($message); ?></div>
                                        <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                    </div>
                                </div>
                                <div class="col-md-4">
                                    <div class="form-group">
                                        <label>TIN Number</label>
                                        <input name="tin_number"
                                            class="form-control <?php $__errorArgs = ['tin_number'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>" type="text"
                                            placeholder="Enter TIN Number"
                                            value="<?php echo e(old('tin_number', $supplier->tin_number)); ?>" id="tin_number">
                                        <?php $__errorArgs = ['tin_number'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                            <div class="invalid-feedback"><?php echo e($message); ?></div>
                                        <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                    </div>
                                </div>


                                <div class="col-md-12">
                                    <strong>
                                        <h5>Upload Documents</h5>
                                    </strong>
                                </div>

                                <?php for($i = 1; $i <= 7; $i++): ?>
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <input class="form-control <?php $__errorArgs = ['doc_name_' . $i];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>"
                                                type="text" placeholder="Enter Name"
                                                name="doc_name_<?php echo e($i); ?>" id="doc_name_<?php echo e($i); ?>"
                                                value="<?php echo e(old('doc_name_' . $i, $supplier->{'doc_name_' . $i})); ?>">
                                            <?php $__errorArgs = ['doc_name_' . $i];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                <div class="invalid-feedback"><?php echo e($message); ?></div>
                                            <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                        </div>
                                    </div>
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <input class="form-control" type="file" id="doc_file_<?php echo e($i); ?>"
                                                name="doc_file_<?php echo e($i); ?>">
                                        </div>
                                    </div>
                                    <div class="col-md-4">
                                        <div class="form-group">
                                            <input class="form-control <?php $__errorArgs = ['doc_expiry_' . $i];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>"
                                                type="date" pattern="\d{4}-\d{2}-\d{2}}"
                                                name="doc_expiry_<?php echo e($i); ?>"
                                                id="doc_expiry_<?php echo e($i); ?>"
                                                value="<?php echo e(old('doc_expiry_' . $i, $supplier->{'doc_expiry_' . $i})); ?>">
                                            <?php $__errorArgs = ['doc_expiry_' . $i];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                                <div class="invalid-feedback"><?php echo e($message); ?></div>
                                            <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                        </div>
                                    </div>
                                <?php endfor; ?>
                            </div>
                            <div class="col-md-12">
                                <div class="form-group">
                                    <label>Description</label>
                                    <textarea name="description" class="form-control <?php $__errorArgs = ['description'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?> is-invalid <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>" rows="4"
                                        placeholder="Enter Description"><?php echo e(old('description', $supplier->description)); ?></textarea>
                                    <?php $__errorArgs = ['description'];
$__bag = $errors->getBag($__errorArgs[1] ?? 'default');
if ($__bag->has($__errorArgs[0])) :
if (isset($message)) { $__messageOriginal = $message; }
$message = $__bag->first($__errorArgs[0]); ?>
                                        <div class="invalid-feedback"><?php echo e($message); ?></div>
                                    <?php unset($message);
if (isset($__messageOriginal)) { $message = $__messageOriginal; }
endif;
unset($__errorArgs, $__bag); ?>
                                </div>
                            </div>


                            <button class="btn btn-cust1 float-right" data-toggle="modal" data-target=""
                                type="submit">Update Supplier</button>



                        </form>

                    </div>
                </div>
            </div>
        </div>
    </div>
    <!-- end row -->


    <div class="modal fade bs-example-modal-center1" tabindex="-1" role="dialog" aria-labelledby="mySmallModalLabel"
        aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="col-md-12 text-center">
                        <div class="pt-4 pb-4">
                            <i class="fas fa-check checkp "></i>
                            <h4 class="card-title font-size-18">Successfully Recorded
                            </h4>
                        </div>
                    </div>
                </div>

            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->


    <div class="modal fade bs-example-modal-center2" tabindex="-2" role="dialog" aria-labelledby="mySmallModalLabel"
        aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-body">
                    <div class="col-md-12 text-center">
                        <div class="pt-4 pb-4">
                            <i class="fas fa-times crossp "></i>
                            <h4 class="card-title font-size-18">Submission Failed
                            </h4>
                        </div>
                    </div>
                </div>

            </div>
            <!-- /.modal-content -->
        </div>
        <!-- /.modal-dialog -->
    </div>
    <!-- /.modal -->
<?php $__env->stopSection(); ?>

<?php echo $__env->make('layouts.crusher', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH F:\zampp 2 7.4\htdocs\acpnew-repo\resources\views/crusher/supplier_master/edit.blade.php ENDPATH**/ ?>