<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class ApprovalVoucher extends Model
{
    use SoftDeletes;

    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'approval_vouchers';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'location_id',
        'invoice_no',
        'date',
        'type',
        'warehouse_id',
        'account_id',
        'customer_id',
        'total_quantity',
        'narrations',
        'buyer_name',
        'buyer_mobile',
        'buyer_email',
        'buyer_address',
        'buyer_vat_number',
        'sales_invoice_status',
        'sales_invoice_id',
        'is_signed',
        'signature_path'
    ];


    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
    ];

    //'foreign_key', 'local_key'
    public function items()
    {
        return $this->hasMany('App\ApprovalVoucherItem', 'approval_voucher_id', 'id');
    }

    public function items_cancelled()
    {
        return $this->hasMany('App\ApprovalVoucherItem', 'approval_voucher_id', 'id')->withTrashed();
    }

    public function account()
    {
        return $this->belongsTo('App\AccountMaster', 'account_id', 'id');
    }

    public function sales_invoice()
    {
        return $this->belongsTo('App\SaleInvoice', 'sales_invoice_id', 'id');
    }
}
