<?php

namespace App\Http\Controllers\MainMenu;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Str;

use Auth;
use DB;
use Storage;
use Session;
use Carbon\Carbon;

use App\Services\Slug;

use App\Chat;
use App\Country;
use App\Location;
use App\User;
use App\LocationPermission;
use App\LocationPermissionTrack;

class ChatController extends Controller
{
    protected $slug;

    public function __construct(Slug $slug)
    {
        $this->slug = $slug;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if(Auth::user()->hasRole('user')){
            $permission = LocationPermission::Where('user_id', Auth::user()->id)->get();

            $option = LocationPermissionTrack::Where('user_id', Auth::user()->id)->first();
            $permission_option = $option->permission_option;

            foreach ($permission as $perm) {
                $countries[] =  Country::Where('id', $perm->country_id)->first();
            }
            $countries = array_unique($countries);

            $user_id = Auth::user()->id;

            $super_admins = User::role('super-admin')->get();
            return view('user.main_menu.chat.index', compact('user_id','countries', 'permission_option', 'super_admins'));

        }
        else{
            $countries = Country::all();
            $permission_option = "all_countries_all_locations";
            $user_id = Auth::user()->id;
            $super_admins = User::role('super-admin')->Where('id', '!=', Auth::user()->id)->get();
            // dd($user_id);
            return view('user.main_menu.chat.index', compact('user_id','countries', 'permission_option', 'super_admins'));
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function live(Request $request)
    {
        $country_id = $request-> country;
        $location_id = $request-> location;
        $receiver_id = $request-> user;
        $sender_receiver = Auth::user()->id . '-' . $receiver_id;
        $receiver_sender = $receiver_id . '-' . Auth::user()->id;
        $chat_to_user = User::where('id', $receiver_id)->first();
        $chat = Chat::where('sender_receiver', $sender_receiver)->orWhere('sender_receiver', $receiver_sender)->orWhere('receiver_sender', $receiver_sender)->orWhere('receiver_sender', $sender_receiver)->first();
        if(!$chat){
            $chat = new Chat();
            $chat-> uuid = Str::uuid();
            $chat-> sender_receiver = $sender_receiver;
            $chat-> receiver_sender = $receiver_sender;
            $chat-> save();
        }
        return view('user.main_menu.chat.live_chat', compact('chat',  'chat_to_user', 'country_id', 'location_id', 'receiver_id'));
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Chat  $chat
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Chat  $chat
     * @return \Illuminate\Http\Response
     */
    public function edit(Chat $chat)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Chat  $chat
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Chat $chat)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Chat  $chat
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
