<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class OpeningBalance extends Model
{
    use SoftDeletes;
    // RELATIONS
    public function item()
    {
        return $this->belongsTo(ItemName::class, 'item_id', 'id');
    }

    public function warehouse()
    {
        return $this->belongsTo(AdminWarehouse::class, 'warehouse_id', 'id');
    }

    public function unit()
    {
        return $this->belongsTo(ItemUnit::class, 'unit_id', 'id');
    }
    public function customer()
    {
        return $this->belongsTo(Customer::class, 'account_id', 'id');
    }
    public function supplier()
    {
        return $this->belongsTo(Supplier::class, 'account_id', 'id');
    }
    public function StaffAndSalesman()
    {
        return $this->belongsTo(StaffAndSalesman::class, 'account_id', 'id');
    }
    public function Expense()
    {
        return $this->belongsTo(Expense::class, 'account_id', 'id');
    }
    public function AdminOtherAccount()
    {
        return $this->belongsTo(AdminOtherAccount::class, 'account_id', 'id');
    }
}
