<?php

namespace App\Services;
use Illuminate\Http\Request;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\ClassOfAccount;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use Carbon\Carbon;
use PDF;
use Auth;
use App\Customer;
use App\Expense;
use App\Supplier;
use App\StaffAndSalesman;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\WarehouseTransfer;
use App\AdminPurchaesInvoice;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use Illuminate\Support\Facades\DB;

class DiscountReportService
{
    public function DiscountReportServiceClosingBalance($request)
    {
        $lastFromDate = date("2003-01-01");
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $lastDay = Carbon::parse($to_date)->subDay()->format('Y-m-d');
        // dd($lastDay, $lastFromDate);

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));


        $CreateObEexpense = Expense::where('branch_id', session()->get('selected_branch'))
        ->where('date', '>=', $from_date . ' 00:00:00')
        ->where('date', '<=', $to_date . ' 23:59:59')
        ->where('account_name', 'Discount')
        ->first();

        if ($CreateObEexpense) {
            $ExpenseAccountId = $CreateObEexpense->id;
            if ($CreateObEexpense->type == 'debit') {
                $createDebitOB = $CreateObEexpense->opening_balance;
                $createCreditOB = null;
            } elseif ($CreateObEexpense->type == 'credit') {
                $createDebitOB = null;
                $createCreditOB = $CreateObEexpense->opening_balance;
            } else {
                $createDebitOB = null;
                $createCreditOB = null;
            }
        } else {
            $ExpenseAccountId = null;
            $createDebitOB = null;
            $createCreditOB = null;
        }

        $CreateObalanceEexpense = Expense::where('branch_id', session()->get('selected_branch'))
        ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
        ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
        ->where('account_name', 'Discount')
        ->first();

        if ($CreateObalanceEexpense) {
            $ExpenseAccountId = $CreateObalanceEexpense->id;
            if ($CreateObalanceEexpense->type == 'debit') {
                $createDebitOBalance = $CreateObalanceEexpense->opening_balance;
                $createCreditOBalance = null;
            } elseif ($CreateObalanceEexpense->type == 'credit') {
                $createDebitOBalance = null;
                $createCreditOBalance = $CreateObalanceEexpense->opening_balance;
            } else {
                $createDebitOBalance = null;
                $createCreditOBalance = null;
            }
        } else {
            $ExpenseAccountId = null;
            $createDebitOBalance = null;
            $createCreditOBalance = null;
        }


        // dd($ExpenseAccountId,$debitOB,$creditOB);

        $customer = Customer::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $supplier = Supplier::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $expense = Expense::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $adminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->get()->toArray();

        $allAccounts = array_merge($customer, $staffAndSalesman, $supplier, $expense, $adminOtherAccount);

        $ncustomer = Customer::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nsupplier = Supplier::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nexpense = Expense::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nadminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();

        $allAccountIds = array_merge($ncustomer, $nstaffAndSalesman, $nsupplier, $nexpense, $nadminOtherAccount);
        // dd($allAccountIds);
        $PurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('invoice_no', 'asc')
            ->get();

        $PurchaesInvoiceTotal = $PurchaesInvoice->sum('discount');

        $SaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $saleInvoiceTotal = $SaleInvoice->sum('discount');


        $Quotation = Quotation::with('expense')->where('branch_id', session()->get('selected_branch'))
        ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('quotation_no')
            ->get();

        $QuotationTotal = $Quotation->sum('discount_amount');

        $debitTotal = $createDebitOB + $saleInvoiceTotal + $QuotationTotal;

        $creditTotal = $createCreditOB + $PurchaesInvoiceTotal;


        $ObPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
        ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
        ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
        ->whereNull('deleted_at')
        ->groupBy('invoice_no')
        ->get()
        ->sum('discount');

        $ObSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            ->sum('discount');

        $ObQuotation = Quotation::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('quotation_no')
            ->get()
            ->sum('discount_amount');

        $ObDebit = null;
        $ObCredit = null;

        $ObdebitTotal = $createDebitOBalance + $ObSaleInvoice + $ObQuotation;
        $ObcreditTotal = $createCreditOBalance + $ObPurchaesInvoice;

        if ($ObdebitTotal > $ObcreditTotal) {
                $ObDebit = $ObdebitTotal - $ObcreditTotal;
            } elseif ($ObdebitTotal < $ObcreditTotal) {
                $ObCredit = $ObcreditTotal - $ObdebitTotal;
            }

        $DebitopeningBalance = $ObDebit;
        $creditOpeningBalance = $ObCredit;

         // Closing Balance

         $DebitCB = $debitTotal + $DebitopeningBalance;

         $CreditCB = $creditTotal + $creditOpeningBalance;

         // Calculate the closing balance
         $ClosingBalance = $DebitCB - $CreditCB;

         // Initialize variables for positive and negative closing balances
         $debitDiscountReportCB = 0;
         $creditDiscountReportCB = 0;

         // Determine if the closing balance is positive or negative
         if ($ClosingBalance > 0) {
             // If positive, store it in the positive closing balance variable
             $debitDiscountReportCB = $ClosingBalance;
         } elseif ($ClosingBalance < 0) {
             // If negative, store its absolute value in the negative closing balance variable
             $creditDiscountReportCB = abs($ClosingBalance);
         }

         return [$debitDiscountReportCB,$creditDiscountReportCB,$from_date, $to_date,];

    }

}
