<?php

namespace App\Services;
use Illuminate\Http\Request;
use App\AccountMaster;
use App\AccountMastersAccountsDetail;
use App\ClassOfAccount;
use App\Currency;
use App\Http\Controllers\Controller;
use App\PurchaseInvoice;
use App\PurchaseReturnVoucher;
use App\SaleInvoice;
use App\SalesReturnVoucher;
use App\Services\Utils;
use Carbon\Carbon;
use PDF;
use Auth;
use App\Customer;
use App\Expense;
use App\Supplier;
use App\StaffAndSalesman;
use App\AdminOtherAccount;
use App\AdminSalesInvoice;
use App\AdminJournalVoucher;
use App\AdminReceiptVoucher;
use App\ReceiptVoucherExpense;
use App\PaymentVoucherExpense ;
use App\Company;
use App\DeliveryNote;
use App\CreditNote;
use App\DebitNote;
use App\OpeningBalance;
use App\PurchaseOrder;
use App\Quotation;
use App\WarehouseTransfer;
use App\AdminPurchaesInvoice;
use App\AdminPaymentVoucher;
use App\AdminTermsAndCondition;
use Illuminate\Support\Facades\DB;

class VatReportService
{

    public function vatReportClosingBalance($request)
    {
        $lastFromDate = date("2003-01-01");
        $from_date = $request->from_date;
        $to_date = $request->to_date;
        $lastDay = Carbon::parse($to_date)->subDay()->format('Y-m-d');

        $currentYearFirstDate = date("2003-01-01");
        $oneDayPreviousDate = date('Y-m-d', strtotime('-1 day', strtotime($from_date)));

        $createObVat = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->where('account_name', 'VAT')
            ->first();

            if ($createObVat) {
                $VatAccountId = $createObVat->id;
                $VatAccountDate = $createObVat->date;
                if ($createObVat->type == 'debit') {
                    $createDebitOB = $createObVat->opening_balance;
                    $createCreditOB = null;
                } elseif ($createObVat->type == 'credit') {
                    $createDebitOB = null;
                    $createCreditOB = $createObVat->opening_balance;
                } else {
                    $createDebitOB = null;
                    $createCreditOB = null;
                }
            } else {
                $VatAccountId = null;
                $VatAccountDate = null;
                $createDebitOB = null;
                $createCreditOB = null;
            }

        $createObalanceVat = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->where('account_name', 'VAT')
            ->first();

            if ($createObalanceVat) {
                $obVatAccountId = $createObalanceVat->id;
                // $VatAccountDate = $createObalanceVat->date;
                if ($createObalanceVat->type == 'debit') {
                    $createDebitOBalance = $createObalanceVat->opening_balance;
                    $createCreditOBalance = null;
                } elseif ($createObalanceVat->type == 'credit') {
                    $createDebitOBalance = null;
                    $createCreditOBalance = $createObalanceVat->opening_balance;
                } else {
                    $createDebitOBalance = null;
                    $createCreditOBalance = null;
                }
            } else {
                $obVatAccountId = null;
                // $VatAccountDate = null;
                $createDebitOBalance = null;
                $createCreditOBalance = null;
            }

        // dd($VatAccountId,$createDebitOB,$createCreditOB);

        $customer = Customer::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $staffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $supplier = Supplier::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $expense = Expense::where('branch_id', session()->get('selected_branch'))->get()->toArray();
        $adminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->get()->toArray();

        $allAccounts = array_merge($customer, $staffAndSalesman, $supplier, $expense, $adminOtherAccount);

        $ncustomer = Customer::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nstaffAndSalesman = StaffAndSalesman::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nsupplier = Supplier::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nexpense = Expense::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();
        $nadminOtherAccount = AdminOtherAccount::where('branch_id', session()->get('selected_branch'))->pluck('id')->toArray();

        $allAccountIds = array_merge($ncustomer, $nstaffAndSalesman, $nsupplier, $nexpense, $nadminOtherAccount);

        $PurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('invoice_no', 'asc')
            ->get();

        $PurchaesInvoiceTotal = $PurchaesInvoice->sum('total_vat_amount');


        $SaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $saleInvoiceTotal = $SaleInvoice->sum('total_vat_amount');


        $CreditNote = CreditNote::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $creditNoteInvoiceTotal = $CreditNote->sum('total_vat_amount');

        $DebitNote = DebitNote::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $debitNoteInvoiceTotal = $DebitNote->sum('total_vat_amount');

        $PaymentVouchers = AdminPaymentVoucher::with('expense')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $to_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $PaymentVoucherTotal = null;

        foreach ($PaymentVouchers as $PaymentVoucher) {
            $mergedExpenses = $PaymentVoucher->expense
                ->whereIn('account_id', $allAccountIds)
                ->groupBy('invoice_no')
                ->map(function ($group) {
                    return [
                        'invoice_no' => $group->first()->invoice_no,
                        'total_amount' => $group->sum('new_vat_amount'),
                    ];
                })
                ->values();

            $PaymentVoucher->mergedExpenses = $mergedExpenses;

            // Sum up the total amount

            $PaymentVoucherTotal += $mergedExpenses->sum('total_amount');
        }

        // dd($PaymentVouchersTotal);

        $PurchaseOrder = PurchaseOrder::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $from_date . ' 00:00:00')
            ->where('date', '<=', $from_date . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->orderBy('date', 'asc')
            ->get();

        $PurchaseOrderTotal = $PurchaseOrder->sum('total_vat_amount');


        $debitTotal = $createDebitOB + $PurchaesInvoiceTotal + $creditNoteInvoiceTotal + $PaymentVoucherTotal + $PurchaseOrderTotal;

        $creditTotal = $createCreditOB + $saleInvoiceTotal + $debitNoteInvoiceTotal;

        $ObPurchaesInvoice = AdminPurchaesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObSaleInvoice = AdminSalesInvoice::where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObCreditNote = CreditNote::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObDebitNote = DebitNote::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObPurchaseOrder = PurchaseOrder::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObQuotation = Quotation::with('expense')->where('branch_id', session()->get('selected_branch'))
            ->whereIn('account_id', $allAccountIds)

            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('quotation_no')
            ->get()
            // ->toArray();
            ->sum('total_vat_amount');

        $ObPaymentVouchers = AdminPaymentVoucher::with('expense')
            ->where('branch_id', session()->get('selected_branch'))
            ->where('date', '>=', $currentYearFirstDate . ' 00:00:00')
            ->where('date', '<=', $oneDayPreviousDate . ' 23:59:59')
            ->whereNull('deleted_at')
            ->groupBy('invoice_no')
            ->get();

            $mergedReceipts = $ObPaymentVouchers->flatMap(function ($receiptVoucher) {
                return $receiptVoucher->expense->groupBy('invoice_no')->map(function ($group) {
                    return [
                        'invoice_no' => $group->first()->invoice_no,
                        'total_vat_amount' => $group->sum('new_vat_amount'),
                    ];
                });
            });

        $ObObPaymentVouchersTotalAmount = $mergedReceipts->sum('total_vat_amount');

        $ObDebit =null;
        $ObCredit =null;

        $ObdebitTotal = $createDebitOBalance + $ObPurchaesInvoice + $ObCreditNote + $ObPurchaseOrder + $ObQuotation + $ObObPaymentVouchersTotalAmount;
        $ObcreditTotal = + $createCreditOBalance + $ObSaleInvoice  + $ObDebitNote;
        // dd($ObdebitTotal,$ObcreditTotal);

        if ($ObdebitTotal > $ObcreditTotal) {
            $ObDebit = $ObdebitTotal - $ObcreditTotal;
        } elseif ($ObdebitTotal < $ObcreditTotal) {
            $ObCredit = $ObcreditTotal - $ObdebitTotal;
        }

        $DebitopeningBalance = $ObDebit;
        $creditOpeningBalance = $ObCredit;

        // Closing Balance

        $DebitCB = $debitTotal + $DebitopeningBalance;

        $CreditCB = $creditTotal + $creditOpeningBalance;

        // Calculate the closing balance
        $ClosingBalance = $DebitCB - $CreditCB;

        // Initialize variables for positive and negative closing balances
        $debitVatReportCB = 0;
        $creditVatReportCB = 0;

        // Determine if the closing balance is positive or negative
        if ($ClosingBalance > 0) {
            // If positive, store it in the positive closing balance variable
            $debitVatReportCB = $ClosingBalance;
        } elseif ($ClosingBalance < 0) {
            // If negative, store its absolute value in the negative closing balance variable
            $creditVatReportCB = abs($ClosingBalance);
        }

        return [$debitVatReportCB,$creditVatReportCB,$from_date, $to_date,];

    }


}
