<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class WareHouse extends Model
{
    use SoftDeletes;
    //
     //
    /**
     * The table associated with the model.
     *
     * @var string
     */
    protected $table = 'ware_houses';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'location_id',
        'name',
        'slug',
        'show_user',
        'status'
    ];


    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
    ];

    public function items()
    {
        return $this->hasMany('App\PurchaseInvoiceItem', 'warehouse_id', 'id');
    }
    
}
