@extends('layouts.master_user_without_nav')
@section('css')
<style>
    .margin_top{
        margin-top: 50px;
    }
    h2{
        margin-bottom: 20px;
    }

</style>
@endsection
@section('content')
<div class="middle-box text-center animated fadeInDown">
    <div class="row text-left" style="margin-bottom: 20px;">
        <a href="/" class="btn btn-primary">Go Back</a>
    </div>
    @include('errors.list')
        <div class="row gray-bg">
            <h2><strong>Select User, Country & Location </strong></h2>
        </div>
        <form class="margin_top" method="GET" role="form" action="{{url('/main-menu/live-chat')}}">

            <div class="form-group">
                <label for="country">Chat Option</label>
                <select name="chat_option" id="chat_option" class="form-control" onchange="changeOption()" required>
                    <option value="">Select Chat With...</option>
                    <option value="admin">Admin</option>
                    <option value="user">User</option>
                </select>
            </div>

            <div id="chat_with_admin" style="display:none">
                <div class="form-group">
                    <label for="country">Select Admin</label>
                    <select name="user" id="admin" class="form-control" required>
                        <option value="">Select Admin</option>
                            @foreach ($super_admins as $super_admin)
                                <option value="{{$super_admin-> id}}">{{$super_admin-> email}}</option>
                            @endforeach
                    </select>
                </div>
            </div>


            <div id="chat_with_user" style="display:none">
                <div class="form-group">
                    <label for="country">Select Country</label>
                    <select name="country" id="country" class="form-control" required>
                        <option value="">Select Country</option>
                            @foreach ($countries as $country)
                                <option value="{{$country-> id}}">{{$country-> name}}</option>
                            @endforeach
                    </select>
                </div>
                <input type="hidden" name="permission_option" id="permission_option" value="{{$permission_option}}">
                <div class="form-group">
                    <label for="location">Select Location</label>
                <select name="location" id="location" class="form-control" required>
                </select>
                </div>
                <div class="form-group">
                    <label for="user">Select User</label>
                <select name="user" id="user" class="form-control" required>
                </select>
                </div>
                <input type="hidden" id="user_id" name="user_id" value="{{$user_id}}">
            </div>
            <button type="submit" class="btn btn-primary block full-width m-b">Continue</button>
        </form>
</div>
@endsection

@section('js')
<script>

    $('select[name="location"]').on('change', function(){
        var location_id = $(this).val();
        var admin_user = $("#chat_option").val();
        var user_id = $('#user_id').val();
        // alert(user_id);
        if(location_id && admin_user) {
            $.ajax({
                url: '/users-permission/'+location_id+'/'+admin_user+'/'+user_id,
                type:"GET",
                dataType:"json",
                success:function(data) {
                    console.log("data", data.data);
                    if(data.status == "success") {
                        $('#user').empty();
                        $.each(data.data, function(key, value){
                            $('#user').append('<option value="'+ value.id +'">' + value.email + '</option>');
                        });

                    }else {
                        alert('failed to retrieve users for selected location');
                    }

                },
            });
        } else {
            alert("Kindly Fill Above Fields First");
            $('select[name="location"]').empty();
            $('#user').empty();
            $('select[name="country"]').val("");
        }
    });

    function changeOption(){
            var chat_option = $("#chat_option").val();
            if(chat_option == 'admin'){
                $('#chat_with_admin').css('display', 'block');
                $('#chat_with_user').css('display', 'none');
                // $('select[name="location"]').empty();
                // $('select[name="user"]').empty();
                // $('select[name="country"]').val("");
                $('select[name="location"]').prop('required',false);
                $('#user').prop('required',false);
                $('select[name="country"]').prop('required',false);
                $('#admin').prop('required',true);
            }else{
                $('#chat_with_admin').css('display', 'none');
                $('#chat_with_user').css('display', 'block');
                // $('select[name="user_id"]').empty();
                $('#admin').prop('required',false);
                $('select[name="location"]').prop('required',true);
                $('#user').prop('required',true);
                $('select[name="country"]').prop('required',true);
            }
    }
</script>
@endsection
