@extends('layouts.master_user')
@section('page-title')
Item Unit Master
@endsection
@section('css')
<style>
    .top {
        margin-top: 22px;
    }
</style>

@endsection
@section('master')
active
@endsection
@section('item-units')
active
@endsection
@section('content')
{{--
@section('page-breadcrumb')
<li>
    <a href="{{url('/')}}">Dashboard</a>
</li>
<li class="active">
    <strong>Customer Master</strong>
</li>
@endsection--}}

<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="ibox float-e-margins">
        {{-- <div class="ibox-title">
            <h5>Add Customers</h5>
            <div class="ibox-tools">
                <a class="collapse-link">
                    <i class="fa fa-chevron-up"></i>
                </a>
            </div>
        </div> --}}
        <div class="ibox-content">
            <form id="create_form" class="form-horizontal" method="POST" action="/masters/item-units" enctype="multipart/form-data">
                @csrf
                <div class="form-group">
                        <div class="col-sm-12">
                            <div class="table-responsive">
                                <table class="table table-bordered table-hover" id="item_table">
                                    <thead>
                                        <tr>
                                            <th scope="col">Item Unit</th>
                                            <th scope="col">Delete</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                            <td>
                                                <input type="text" id="name" name="unit[]"
                                                    placeholder="Item Unit"class="form-control"
                                                    required />
                                            </td>
                                            <td>
                                                <button type="button" class="btn" id="delete_item_button" disabled><i
                                                        class="fa fa-trash-o icon-trash"></i></button>
                                            </td>
                                            </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-3 ">
                        <button type="button" class="btn btn-primary"
                        onclick="createItemRow(1)"><i class="feather icon-plus"></i> Add Item Unit
                        </button>
                    </div>
                </div>
                <div class="form-group">
                    <div class="col-sm-12">
                        <button class="btn btn-primary pull-right" type="submit">Save Item Unit</button>
                    </div>
                </div>
                <input type="hidden" id="items_rows" name="items_rows" value="1" />
            </form>
        </div>
    </div>
</div>
@endsection

@section('js')
<script>
    $('#create_form').validate(
        {ignore : ":hidden:not(.selectpicker)"  }
    );
    
    var items_rows = 1;
    var del_rows = 0;
    var item_row_ids = [1];

function createItemRow() {
    items_rows++;
    item_row_ids.push(items_rows);
    var item_row_ids_str = (item_row_ids.toString());
    $('#items_rows').val(item_row_ids_str);

    $('#item_table').append('<tr><td><input type="text" id="name" name="unit[]" placeholder="Item Unit" class="form-control" required /></td>' +
        '<td><button type="button" class="btn" id="delete_item_button"><i class="fa fa-trash-o icon-trash"></i></button></td>' +
        '</tr>');

        console.log(item_row_ids.length);
}

$('#item_table').on('click', 'button[id="delete_item_button"]', function () {
    $(this).closest('tr').remove();
    });

        function deleteItemRow(items_rows_id) {
            del_rows += 1;
            item_row_ids = $.grep(item_row_ids, function (value) {
                return value != items_rows_id;
            });
            var item_row_ids_str = (item_row_ids.toString());
            $('#items_rows').val(item_row_ids_str);
        }


</script>
@endsection
