@extends('layouts.master_user')
@section('page-title')
Country/Location Wise Stock Transfer
@endsection
@section('css')
<style>
    th {
        text-align: center;
    }

    td {
        text-align: center;
    }
</style>

@endsection
@section('transaction')
active
@endsection
@section('country-location-wise-transfer')
active
@endsection
@section('stock-transfer')
active
@endsection
@section('content')
<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="row wrapper white-bg page-heading">
        <div class="col-md-12">
            <a href="/transactions/country-location-wise-transfer/stock-transfers/create" class="btn btn-primary pull-right"><i class="fa fa-plus" aria-hidden="true"></i> Create Country Location Stock Transfer</a>
        </div>
        @if(count($country_location_wise_stock_transfers) != 0)
        <div class="col-md-12">
            <div class="card strpied-tabled-with-hover" style="padding-top: 20px;">
                <div class="card-body">
                    <div class="table-responsive">
                        <table class="table table-striped table-bordered table-hover dt-responsive" >
                        <thead>
                        <tr>
                            <th>Invoice No</th>
                            <th>Date</th>
                            <th>Action</th>
                        </tr>
                        </thead>
                        <tbody>
                            @foreach($country_location_wise_stock_transfers as $country_location_wise_stock_transfer)
                            <tr>
                                <td>{{ $country_location_wise_stock_transfer->country_location_wise_stock_transfer_no }}</td>
                                <td>{{ $country_location_wise_stock_transfer->date }}</td>
                                <td>
                                    @if ($country_location_wise_stock_transfer->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">
                                            @can('edit-country-location-wise-stock-transfer')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/country-location-wise-transfer/stock-transfers/{{ $country_location_wise_stock_transfer->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan
                                            {{-- <div class="pull-right">
                                                <form  method="post" action="/transactions/country-location-wise-stock-transfer->id }}">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                                </form>
                                            </div> --}}
                                            @can('cancel-country-location-wise-stock-transfer')
                                            <div class="pull-right">
                                                <form  method="post" action="/transactions/country-location-wise-transfer/stock-transfers/{{ $country_location_wise_stock_transfer->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                        </div>
                                    @endif
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                        @if ($country_location_wise_stock_transfers->hasPages())
                        <tfoot>
                            <tr>
                                <td colspan="5" class="footable-visible text-center">
                                    {!! $country_location_wise_stock_transfers->links() !!}
                                </td>
                            </tr>
                        </tfoot>
                        @endif
                        </table>
                    </div>
                </div>
            </div>
        </div>
        @else
            <h4 style="text-align:center;">No Country Location Wise Stock Transfer has been created yet.</h4>
        @endif
    </div>
</div>
@endsection

@section('js')
<script>
    $(document).ready(function(){
        $('.dataTables-$country_location_wise_stock_transfers').DataTable({
            pageLength: 25,
            dom: '<"html5buttons"B>lTfgitp',
            buttons: [
                { extend: 'copy'},
                {extend: 'csv'},
                {extend: 'excel', title: 'ExampleFile'},
                {extend: 'pdf', title: 'ExampleFile'},

                {extend: 'print',
                 customize: function (win){
                        $(win.document.body).addClass('white-bg');
                        $(win.document.body).css('font-size', '10px');

                        $(win.document.body).find('table')
                                .addClass('compact')
                                .css('font-size', 'inherit');
                }
                }
            ]

        });

    });

</script>
@endsection
