@extends('layouts.master_user')
@section('page-title')
Receipt Voucher
@endsection
@section('css')
<style>
    .table-responsive {
        display: block;
        width: 100%;
        overflow-x: auto;
        -webkit-overflow-scrolling: touch;
    }

    .table-responsive>.table-bordered {
        border: 0;
    }
    th{
        text-align: center;
    }
</style>

@endsection
@section('transaction')
active
@endsection
@section('receipt-voucher')
active
@endsection
@section('content')
<div class="wrapper wrapper-content animated fadeInRight">

    @include('errors.list')

    <div class="row wrapper white-bg page-heading">
        <div class="col-md-12">
            <a href="/transactions/receipt-vouchers/create" class="btn btn-primary pull-right"><i class="fa fa-plus" aria-hidden="true"></i> Create Receipt Voucher</a>
        </div>
        @if(count($receipt_vouchers) != 0)
        <div class="col-md-12">
            <div class="card strpied-tabled-with-hover" style="padding-top: 20px;">
                <div class="card-body">
                    <div class="table-responsive">
                        <table class="table table-striped table-bordered table-hover dt-responsive" >
                        <thead>
                        <tr>
                            <th>Invoice No</th>
                            <th>Date</th>
                            {{-- <th>Total Amount</th>
                            <th>Account Name</th> --}}
                            <th>Action</th>
                        </tr>
                        </thead>
                        <tbody>
                            @foreach($receipt_vouchers as $receipt_voucher)
                            <tr>
                                <td>{{ $receipt_voucher->invoice_no }}</td>
                                <td>{{ $receipt_voucher->date }}</td>
                                {{-- <td>{{ $receipt_voucher->amount }}</td>
                                <td>{{ $receipt_voucher->account->name_of_organisation }}</td> --}}
                                <td>
                                    @if ($receipt_voucher->deleted_at != "")
                                        <button type="button" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancelled</button>
                                    @else
                                        <div class="btn-group">
                                            {{-- <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/receipt-vouchers/{{ $receipt_voucher->id }}/edit" class="btn btn-primary"><i class="fa fa-eye" aria-hidden="true"></i> View</a>
                                            </div> --}}
                                            @can('edit-receipt-voucher')
                                            <div class="pull-left" style="margin-right: 10px;">
                                                <a href="/transactions/receipt-vouchers/{{ $receipt_voucher->id }}/edit" class="btn btn-primary"><i class="fa fa-pencil" aria-hidden="true"></i> Edit</a>
                                            </div>
                                            @endcan
                                            {{-- <div class="pull-right">
                                                <form  method="post" action="/transactions/receipt-vouchers/{{ $receipt_voucher->id }}">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Delete</button>
                                                </form>
                                            </div> --}}
                                            @can('cancel-receipt-voucher')
                                            <div class="pull-right">
                                                <form  method="post" action="/transactions/receipt-vouchers/{{ $receipt_voucher->id }}/softdelete">
                                                    {{ csrf_field() }}
                                                    {{ method_field('DELETE') }}
                                                    <button type="submit" class="btn btn-primary"><i class="fa fa-trash" aria-hidden="true"></i> Cancel</button>
                                                </form>
                                            </div>
                                            @endcan
                                        </div>
                                    @endif
                                </td>
                            </tr>
                            @endforeach
                        </tbody>
                        @if ($receipt_vouchers->hasPages())
                        <tfoot>
                            <tr>
                                <td colspan="5" class="footable-visible text-center">
                                    {!! $receipt_vouchers->links() !!}
                                </td>
                            </tr>
                        </tfoot>
                        @endif
                        </table>
                    </div>
                </div>
            </div>
        </div>
        @else
            <h4 style="text-align:center;">No Receipt Voucher has been created yet.</h4>
        @endif
    </div>
</div>
@endsection

@section('js')
<script>
    $(document).ready(function(){
        $('.dataTables-receipt_vouchers').DataTable({
            pageLength: 25,
            dom: '<"html5buttons"B>lTfgitp',
            buttons: [
                { extend: 'copy'},
                {extend: 'csv'},
                {extend: 'excel', title: 'ExampleFile'},
                {extend: 'pdf', title: 'ExampleFile'},

                {extend: 'print',
                 customize: function (win){
                        $(win.document.body).addClass('white-bg');
                        $(win.document.body).css('font-size', '10px');

                        $(win.document.body).find('table')
                                .addClass('compact')
                                .css('font-size', 'inherit');
                }
                }
            ]

        });

    });

</script>
@endsection
